searchData={"items":[{"type":"module","title":"AshJsonApi","doc":"Introspection functions for `AshJsonApi` domains.\n\nFor domain DSL documentation, see `AshJsonApi.Domain`.\n\nFor Resource DSL documentation, see `AshJsonApi.Resource`\n\nTo get started, see the [getting started guide](/documentation/tutorials/getting-started-with-ash-json-api.md)","ref":"AshJsonApi.html"},{"type":"function","title":"AshJsonApi.authorize?/1","doc":"See  AshJsonApi.Domain.Info.authorize?/1 .","ref":"AshJsonApi.html#authorize?/1"},{"type":"function","title":"AshJsonApi.log_errors?/1","doc":"See  AshJsonApi.Domain.Info.log_errors?/1 .","ref":"AshJsonApi.html#log_errors?/1"},{"type":"function","title":"AshJsonApi.prefix/1","doc":"See  AshJsonApi.Domain.Info.prefix/1 .","ref":"AshJsonApi.html#prefix/1"},{"type":"function","title":"AshJsonApi.router/1","doc":"See  AshJsonApi.Domain.Info.router/1 .","ref":"AshJsonApi.html#router/1"},{"type":"function","title":"AshJsonApi.serve_schema?/1","doc":"See  AshJsonApi.Domain.Info.serve_schema?/1 .","ref":"AshJsonApi.html#serve_schema?/1"},{"type":"module","title":"AshJsonApi.Domain","doc":"The entrypoint for adding JSON:API behavior to an Ash domain","ref":"AshJsonApi.Domain.html"},{"type":"function","title":"AshJsonApi.Domain.install/5","doc":"","ref":"AshJsonApi.Domain.html#install/5"},{"type":"macro","title":"AshJsonApi.Domain.json_api/1","doc":"","ref":"AshJsonApi.Domain.html#json_api/1"},{"type":"module","title":"AshJsonApi.Resource","doc":"The entrypoint for adding JSON:API behavior to a resource\"","ref":"AshJsonApi.Resource.html"},{"type":"function","title":"AshJsonApi.Resource.base_route/1","doc":"See  AshJsonApi.Resource.Info.base_route/1 .","ref":"AshJsonApi.Resource.html#base_route/1"},{"type":"function","title":"AshJsonApi.Resource.encode_primary_key/1","doc":"","ref":"AshJsonApi.Resource.html#encode_primary_key/1"},{"type":"function","title":"AshJsonApi.Resource.includes/1","doc":"See  AshJsonApi.Resource.Info.includes/1 .","ref":"AshJsonApi.Resource.html#includes/1"},{"type":"function","title":"AshJsonApi.Resource.install/5","doc":"","ref":"AshJsonApi.Resource.html#install/5"},{"type":"macro","title":"AshJsonApi.Resource.json_api/1","doc":"","ref":"AshJsonApi.Resource.html#json_api/1"},{"type":"function","title":"AshJsonApi.Resource.only_primary_key?/2","doc":"","ref":"AshJsonApi.Resource.html#only_primary_key?/2"},{"type":"function","title":"AshJsonApi.Resource.primary_key_delimiter/1","doc":"See  AshJsonApi.Resource.Info.primary_key_delimiter/1 .","ref":"AshJsonApi.Resource.html#primary_key_delimiter/1"},{"type":"function","title":"AshJsonApi.Resource.primary_key_fields/1","doc":"See  AshJsonApi.Resource.Info.primary_key_fields/1 .","ref":"AshJsonApi.Resource.html#primary_key_fields/1"},{"type":"function","title":"AshJsonApi.Resource.route/3","doc":"","ref":"AshJsonApi.Resource.html#route/3"},{"type":"function","title":"AshJsonApi.Resource.routes/2","doc":"See  AshJsonApi.Resource.Info.routes/2 .","ref":"AshJsonApi.Resource.html#routes/2"},{"type":"function","title":"AshJsonApi.Resource.type/1","doc":"See  AshJsonApi.Resource.Info.type/1 .","ref":"AshJsonApi.Resource.html#type/1"},{"type":"module","title":"AshJsonApi.Router","doc":"Use this module to create a router for your AshJsonApi.\n\nTo use this, create a module and do the following:\n\n```elixir\ndefmodule YourRouter do\n  use AshJsonApi.Router,\n    domains: [YourDomain, YourOtherDomain],\n    # these next two are optional, only add them if you want those endpoints\n    open_api: \"/open_api\",\n    json_schema: \"/json_schema\",\n    # tell us where it is mounted in your router\n    prefix: \"/api/json\"\nend\n```\n\nThen in your Phoenix router or plug pipeline, forward to this plug.\nIn phoenix, that looks like this:\n\n```elixir\n    forward \"/api\", YourRouter\n```","ref":"AshJsonApi.Router.html"},{"type":"module","title":"Customizing request handling - AshJsonApi.Router","doc":"You can provide the `before_dispatch` option to customize request handling.\nThis can also be used to do things like set monitoring/observability information,\nlike which domain/resource/route is handling the request.\n\nFor example:\n\n```elixir\nuse AshJsonApi.Router,\n  ...,\n  before_dispatch: {__MODULE__, :before_dispatch, []}\n\n\ndef before_dispatch(conn, route_info) do\n ...\nend\n```\n\n`route_info` will be one of the following:\n\n- `:open_api` - The open api is being requested\n- `:json_schema` - The json schema is being requested\n- `:not_found` - No matching route was found\n- A map containing the keys: `domain`, `resource`, `route`, `params`","ref":"AshJsonApi.Router.html#module-customizing-request-handling"},{"type":"module","title":"AshJsonApi.OpenApi","doc":"Provides functions for generating schemas and operations for OpenApi definitions.\n\nAdd `open_api_spex` to your `mix.exs` deps for the required struct definitions.","ref":"AshJsonApi.OpenApi.html"},{"type":"module","title":"Example - AshJsonApi.OpenApi","doc":"defmodule MyApp.OpenApi do\n      alias OpenApiSpex.{OpenApi, Info, Server, Components}\n\n      def spec do\n        %OpenApi{\n          info: %Info{\n            title: \"MyApp JSON API\",\n            version: \"1.1\"\n          },\n          servers: [\n            Server.from_endpoint(MyAppWeb.Endpoint)\n          ],\n          paths: AshJsonApi.OpenApi.paths(MyApp.Api),\n          tags: AshJsonApi.OpenApi.tags(MyApp.Api),\n          components: %Components{\n            responses: AshJsonApi.OpenApi.responses(),\n            schemas: AshJsonApi.OpenApi.schemas(MyApp.Api)\n          }\n        }\n      end\n    end","ref":"AshJsonApi.OpenApi.html#module-example"},{"type":"function","title":"AshJsonApi.OpenApi.define_filter?/2","doc":"","ref":"AshJsonApi.OpenApi.html#define_filter?/2"},{"type":"function","title":"AshJsonApi.OpenApi.paths/3","doc":"Paths (routes) from the domain.","ref":"AshJsonApi.OpenApi.html#paths/3"},{"type":"function","title":"AshJsonApi.OpenApi.raw_filter_type/2","doc":"","ref":"AshJsonApi.OpenApi.html#raw_filter_type/2"},{"type":"function","title":"AshJsonApi.OpenApi.resource_filter_fields_fields_only/1","doc":"","ref":"AshJsonApi.OpenApi.html#resource_filter_fields_fields_only/1"},{"type":"function","title":"AshJsonApi.OpenApi.responses/0","doc":"Common responses to include in the API Spec.","ref":"AshJsonApi.OpenApi.html#responses/0"},{"type":"function","title":"AshJsonApi.OpenApi.schemas/1","doc":"Resource schemas to include in the API spec.","ref":"AshJsonApi.OpenApi.html#schemas/1"},{"type":"function","title":"AshJsonApi.OpenApi.spec/2","doc":"","ref":"AshJsonApi.OpenApi.html#spec/2"},{"type":"function","title":"AshJsonApi.OpenApi.tags/1","doc":"Tags based on resource names to include in the API spec","ref":"AshJsonApi.OpenApi.html#tags/1"},{"type":"function","title":"AshJsonApi.OpenApi.tags/2","doc":"","ref":"AshJsonApi.OpenApi.html#tags/2"},{"type":"function","title":"AshJsonApi.OpenApi.write_attributes/5","doc":"","ref":"AshJsonApi.OpenApi.html#write_attributes/5"},{"type":"module","title":"AshJsonApi.Test","doc":"Utilities for testing AshJsonApi.","ref":"AshJsonApi.Test.html"},{"type":"module","title":"Making Requests - AshJsonApi.Test","doc":"The request testing functions get/patch/post/delete all support the following options\n\n- `:status`: Asserts that the response has the provided status after making the request\n- `:router`: The corresponding JsonApiRouter to go through. Can be set statically in config, see below for more.\n- `:actor`: Sets the provided actor as the actor for the request\n- `:tenant`: Sets the provided tenant as the tenant for the request\n\nA standard test would look like this:\n\n```elixir\ntest \"can list posts\", %{current_user: current_user} do\n  Domain\n  # GET /posts\n  # assert resp.status == 200\n  |> get(\"/posts\", status: 200, actor: current_user, router: MyAppWeb.JsonApiRouter)\n  # pattern match on the data key of the response\n  |> assert_data_matches([\n    %{\n      \"attributes\" => %{\n        \"name\" => \"foo\"\n      }\n    }\n  ])\nend\n```","ref":"AshJsonApi.Test.html#module-making-requests"},{"type":"macro","title":"AshJsonApi.Test.assert_data_equals/2","doc":"Assert that the response body's `\"data\"` equals an exact value","ref":"AshJsonApi.Test.html#assert_data_equals/2"},{"type":"macro","title":"AshJsonApi.Test.assert_data_matches/2","doc":"Assert that the response body's `\"data\"` matches a pattern","ref":"AshJsonApi.Test.html#assert_data_matches/2"},{"type":"macro","title":"AshJsonApi.Test.assert_has_error/2","doc":"Asserts that an error is in the response where each key present in the provided map\nhas the same value in the error.","ref":"AshJsonApi.Test.html#assert_has_error/2"},{"type":"macro","title":"Example - AshJsonApi.Test.assert_has_error/2","doc":"```elixir\nDomain\n|> delete(\"/posts/1\", status: 404)\n|> assert_has_error(%{\n  \"code\" => \"not_found\",\n  \"detail\" => \"No post record found with `id: 1`\",\n  \"title\" => \"Entity Not Found\"\n})\n```","ref":"AshJsonApi.Test.html#assert_has_error/2-example"},{"type":"macro","title":"AshJsonApi.Test.assert_has_matching_include/2","doc":"Assert that the given function returns true for at least one included record","ref":"AshJsonApi.Test.html#assert_has_matching_include/2"},{"type":"macro","title":"Example - AshJsonApi.Test.assert_has_matching_include/2","doc":"```elixir\nDomain\n|> get(\"/posts/#{post.id}/?include=author\", status: 200)\n|> assert_has_matching_include(fn\n  %{\"type\" => \"author\", \"id\" => ^author_id} ->\n    true\n\n  _ ->\n    false\nend)\n```","ref":"AshJsonApi.Test.html#assert_has_matching_include/2-example"},{"type":"function","title":"AshJsonApi.Test.delete/3","doc":"Sends a DELETE request to the given path. See the module docs for more.","ref":"AshJsonApi.Test.html#delete/3"},{"type":"function","title":"AshJsonApi.Test.get/3","doc":"Sends a GET request to the given path. See the module docs for more.","ref":"AshJsonApi.Test.html#get/3"},{"type":"function","title":"AshJsonApi.Test.multipart_post/4","doc":"Sends a multipart POST request to the given path. See the module docs for more.","ref":"AshJsonApi.Test.html#multipart_post/4"},{"type":"function","title":"AshJsonApi.Test.patch/4","doc":"Sends a PATCH request to the given path. See the module docs for more.","ref":"AshJsonApi.Test.html#patch/4"},{"type":"function","title":"AshJsonApi.Test.post/4","doc":"Sends a POST request to the given path. See the module docs for more.","ref":"AshJsonApi.Test.html#post/4"},{"type":"macro","title":"AshJsonApi.Test.refute_has_matching_include/2","doc":"Refute that the given function returns true for at least one included record","ref":"AshJsonApi.Test.html#refute_has_matching_include/2"},{"type":"macro","title":"Example - AshJsonApi.Test.refute_has_matching_include/2","doc":"```elixir\nDomain\n|> get(\"/posts/#{post.id}/?include=author\", status: 200)\n|> refute_has_matching_include(fn\n  %{\"type\" => \"author\", \"id\" => ^author_id} ->\n    true\n\n  _ ->\n    false\nend)\n```","ref":"AshJsonApi.Test.html#refute_has_matching_include/2-example"},{"type":"module","title":"AshJsonApi.Domain.Info","doc":"Introspection helpers for AshJsonApi.Domain","ref":"AshJsonApi.Domain.Info.html"},{"type":"function","title":"AshJsonApi.Domain.Info.authorize?/1","doc":"","ref":"AshJsonApi.Domain.Info.html#authorize?/1"},{"type":"function","title":"AshJsonApi.Domain.Info.group_by/1","doc":"","ref":"AshJsonApi.Domain.Info.html#group_by/1"},{"type":"function","title":"AshJsonApi.Domain.Info.include_nil_values?/1","doc":"","ref":"AshJsonApi.Domain.Info.html#include_nil_values?/1"},{"type":"function","title":"AshJsonApi.Domain.Info.log_errors?/1","doc":"","ref":"AshJsonApi.Domain.Info.html#log_errors?/1"},{"type":"function","title":"AshJsonApi.Domain.Info.prefix/1","doc":"","ref":"AshJsonApi.Domain.Info.html#prefix/1"},{"type":"function","title":"AshJsonApi.Domain.Info.router/1","doc":"","ref":"AshJsonApi.Domain.Info.html#router/1"},{"type":"function","title":"AshJsonApi.Domain.Info.routes/1","doc":"","ref":"AshJsonApi.Domain.Info.html#routes/1"},{"type":"function","title":"AshJsonApi.Domain.Info.serve_schema?/1","doc":"","ref":"AshJsonApi.Domain.Info.html#serve_schema?/1"},{"type":"function","title":"AshJsonApi.Domain.Info.show_raised_errors?/1","doc":"","ref":"AshJsonApi.Domain.Info.html#show_raised_errors?/1"},{"type":"function","title":"AshJsonApi.Domain.Info.tag/1","doc":"","ref":"AshJsonApi.Domain.Info.html#tag/1"},{"type":"module","title":"AshJsonApi.Resource.Info","doc":"Introspection helpers for AshJsonApi.Resource","ref":"AshJsonApi.Resource.Info.html"},{"type":"function","title":"AshJsonApi.Resource.Info.base_route/1","doc":"","ref":"AshJsonApi.Resource.Info.html#base_route/1"},{"type":"function","title":"AshJsonApi.Resource.Info.default_fields/1","doc":"","ref":"AshJsonApi.Resource.Info.html#default_fields/1"},{"type":"function","title":"AshJsonApi.Resource.Info.derive_filter?/1","doc":"","ref":"AshJsonApi.Resource.Info.html#derive_filter?/1"},{"type":"function","title":"AshJsonApi.Resource.Info.derive_sort?/1","doc":"","ref":"AshJsonApi.Resource.Info.html#derive_sort?/1"},{"type":"function","title":"AshJsonApi.Resource.Info.include_nil_values?/1","doc":"","ref":"AshJsonApi.Resource.Info.html#include_nil_values?/1"},{"type":"function","title":"AshJsonApi.Resource.Info.includes/1","doc":"","ref":"AshJsonApi.Resource.Info.html#includes/1"},{"type":"function","title":"AshJsonApi.Resource.Info.primary_key_delimiter/1","doc":"","ref":"AshJsonApi.Resource.Info.html#primary_key_delimiter/1"},{"type":"function","title":"AshJsonApi.Resource.Info.primary_key_fields/1","doc":"","ref":"AshJsonApi.Resource.Info.html#primary_key_fields/1"},{"type":"function","title":"AshJsonApi.Resource.Info.routes/2","doc":"","ref":"AshJsonApi.Resource.Info.html#routes/2"},{"type":"function","title":"AshJsonApi.Resource.Info.type/1","doc":"","ref":"AshJsonApi.Resource.Info.html#type/1"},{"type":"module","title":"AshJsonApi.Resource.Route","doc":"Represents a route for a resource","ref":"AshJsonApi.Resource.Route.html"},{"type":"type","title":"AshJsonApi.Resource.Route.t/0","doc":"","ref":"AshJsonApi.Resource.Route.html#t:t/0"},{"type":"module","title":"AshJsonApi.Error","doc":"Represents an AshJsonApi Error","ref":"AshJsonApi.Error.html"},{"type":"function","title":"AshJsonApi.Error.class_to_status/1","doc":"Turns an error class into an HTTP status code","ref":"AshJsonApi.Error.html#class_to_status/1"},{"type":"function","title":"AshJsonApi.Error.format_log/1","doc":"","ref":"AshJsonApi.Error.html#format_log/1"},{"type":"function","title":"AshJsonApi.Error.new/1","doc":"","ref":"AshJsonApi.Error.html#new/1"},{"type":"type","title":"AshJsonApi.Error.t/0","doc":"","ref":"AshJsonApi.Error.html#t:t/0"},{"type":"function","title":"AshJsonApi.Error.to_json_api_errors/4","doc":"","ref":"AshJsonApi.Error.html#to_json_api_errors/4"},{"type":"function","title":"AshJsonApi.Error.with_source_pointer/4","doc":"","ref":"AshJsonApi.Error.html#with_source_pointer/4"},{"type":"exception","title":"AshJsonApi.Error.InvalidBody","doc":"Returned when the request body provided is invalid","ref":"AshJsonApi.Error.InvalidBody.html"},{"type":"function","title":"AshJsonApi.Error.InvalidBody.exception/1","doc":"Create an `Elixir.AshJsonApi.Error.InvalidBody` without raising it.","ref":"AshJsonApi.Error.InvalidBody.html#exception/1"},{"type":"function","title":"Keys - AshJsonApi.Error.InvalidBody.exception/1","doc":"- :json_xema_error","ref":"AshJsonApi.Error.InvalidBody.html#exception/1-keys"},{"type":"exception","title":"AshJsonApi.Error.InvalidField","doc":"Returned when a field is requested that does not exist or is invalid","ref":"AshJsonApi.Error.InvalidField.html"},{"type":"function","title":"AshJsonApi.Error.InvalidField.exception/1","doc":"Create an `Elixir.AshJsonApi.Error.InvalidField` without raising it.","ref":"AshJsonApi.Error.InvalidField.html#exception/1"},{"type":"function","title":"Keys - AshJsonApi.Error.InvalidField.exception/1","doc":"- :type\n- :field\n- :parameter?\n- :detail\n- :source_parameter","ref":"AshJsonApi.Error.InvalidField.html#exception/1-keys"},{"type":"exception","title":"AshJsonApi.Error.InvalidHeader","doc":"Returned when a header provided is invalid","ref":"AshJsonApi.Error.InvalidHeader.html"},{"type":"function","title":"AshJsonApi.Error.InvalidHeader.exception/1","doc":"Create an `Elixir.AshJsonApi.Error.InvalidHeader` without raising it.","ref":"AshJsonApi.Error.InvalidHeader.html#exception/1"},{"type":"function","title":"Keys - AshJsonApi.Error.InvalidHeader.exception/1","doc":"- :json_xema_error","ref":"AshJsonApi.Error.InvalidHeader.html#exception/1-keys"},{"type":"exception","title":"AshJsonApi.Error.InvalidIncludes","doc":"Returned when the includes string provided in the query parameter `include`\nis invalid.","ref":"AshJsonApi.Error.InvalidIncludes.html"},{"type":"function","title":"AshJsonApi.Error.InvalidIncludes.exception/1","doc":"Create an `Elixir.AshJsonApi.Error.InvalidIncludes` without raising it.","ref":"AshJsonApi.Error.InvalidIncludes.html#exception/1"},{"type":"function","title":"Keys - AshJsonApi.Error.InvalidIncludes.exception/1","doc":"- :includes","ref":"AshJsonApi.Error.InvalidIncludes.html#exception/1-keys"},{"type":"type","title":"AshJsonApi.Error.InvalidIncludes.t/0","doc":"","ref":"AshJsonApi.Error.InvalidIncludes.html#t:t/0"},{"type":"exception","title":"AshJsonApi.Error.InvalidPagination","doc":"Returned when one of the nested parameters provided in the query parameter `page` is invalid","ref":"AshJsonApi.Error.InvalidPagination.html"},{"type":"function","title":"AshJsonApi.Error.InvalidPagination.exception/1","doc":"Create an `Elixir.AshJsonApi.Error.InvalidPagination` without raising it.","ref":"AshJsonApi.Error.InvalidPagination.html#exception/1"},{"type":"function","title":"Keys - AshJsonApi.Error.InvalidPagination.exception/1","doc":"- :detail","ref":"AshJsonApi.Error.InvalidPagination.html#exception/1-keys"},{"type":"exception","title":"AshJsonApi.Error.InvalidQuery","doc":"Returned when the query provided is invalid","ref":"AshJsonApi.Error.InvalidQuery.html"},{"type":"function","title":"AshJsonApi.Error.InvalidQuery.exception/1","doc":"Create an `Elixir.AshJsonApi.Error.InvalidQuery` without raising it.","ref":"AshJsonApi.Error.InvalidQuery.html#exception/1"},{"type":"function","title":"Keys - AshJsonApi.Error.InvalidQuery.exception/1","doc":"- :json_xema_error","ref":"AshJsonApi.Error.InvalidQuery.html#exception/1-keys"},{"type":"exception","title":"AshJsonApi.Error.InvalidType","doc":"Returned when a field is requested for a type that does not exist or is invalid","ref":"AshJsonApi.Error.InvalidType.html"},{"type":"function","title":"AshJsonApi.Error.InvalidType.exception/1","doc":"Create an `Elixir.AshJsonApi.Error.InvalidType` without raising it.","ref":"AshJsonApi.Error.InvalidType.html#exception/1"},{"type":"function","title":"Keys - AshJsonApi.Error.InvalidType.exception/1","doc":"- :type","ref":"AshJsonApi.Error.InvalidType.html#exception/1-keys"},{"type":"exception","title":"AshJsonApi.Error.NotFound","doc":"Returned when a record was explicitly requested, but could not be found.","ref":"AshJsonApi.Error.NotFound.html"},{"type":"function","title":"AshJsonApi.Error.NotFound.exception/1","doc":"Create an `Elixir.AshJsonApi.Error.NotFound` without raising it.","ref":"AshJsonApi.Error.NotFound.html#exception/1"},{"type":"function","title":"Keys - AshJsonApi.Error.NotFound.exception/1","doc":"- :filter\n- :resource","ref":"AshJsonApi.Error.NotFound.html#exception/1-keys"},{"type":"exception","title":"AshJsonApi.Error.UnacceptableMediaType","doc":"Returned when the client does not provide (via the `Content-Type` header) the correct json API media type: application/vnd.api+json","ref":"AshJsonApi.Error.UnacceptableMediaType.html"},{"type":"function","title":"AshJsonApi.Error.UnacceptableMediaType.exception/1","doc":"Create an `Elixir.AshJsonApi.Error.UnacceptableMediaType` without raising it.","ref":"AshJsonApi.Error.UnacceptableMediaType.html#exception/1"},{"type":"function","title":"Keys - AshJsonApi.Error.UnacceptableMediaType.exception/1","doc":"","ref":"AshJsonApi.Error.UnacceptableMediaType.html#exception/1-keys"},{"type":"exception","title":"AshJsonApi.Error.UnsupportedMediaType","doc":"Returned when the client does not accept (via the `Accept` header) the json API media type: application/vnd.api+json","ref":"AshJsonApi.Error.UnsupportedMediaType.html"},{"type":"function","title":"AshJsonApi.Error.UnsupportedMediaType.exception/1","doc":"Create an `Elixir.AshJsonApi.Error.UnsupportedMediaType` without raising it.","ref":"AshJsonApi.Error.UnsupportedMediaType.html#exception/1"},{"type":"function","title":"Keys - AshJsonApi.Error.UnsupportedMediaType.exception/1","doc":"","ref":"AshJsonApi.Error.UnsupportedMediaType.html#exception/1-keys"},{"type":"protocol","title":"AshJsonApi.ToJsonApiError","doc":"A protocol for turning an Ash exception into an AshJsonApi.Error\n\nTo use, implement the protocol for a builtin Ash exception type or for your own custom\nAsh exception.","ref":"AshJsonApi.ToJsonApiError.html"},{"type":"protocol","title":"Example - AshJsonApi.ToJsonApiError","doc":"```elixir\ndefmodule NotAvailable do\n  use Ash.Error.Exception\n\n  use Splode.Error,\n    fields: [],\n    class: :invalid\n\n  defimpl AshJsonApi.ToJsonApiError do\n    def to_json_api_error(error) do\n      %AshJsonApi.Error{\n        id: Ash.UUID.generate(),\n        status_code: 409,\n        code: \"not_available\",\n        title: \"not_available\",\n        detail: \"Not available\"\n      }\n    end\n  end\nend\n```","ref":"AshJsonApi.ToJsonApiError.html#module-example"},{"type":"type","title":"AshJsonApi.ToJsonApiError.t/0","doc":"All the types that implement this protocol.","ref":"AshJsonApi.ToJsonApiError.html#t:t/0"},{"type":"function","title":"AshJsonApi.ToJsonApiError.to_json_api_error/1","doc":"","ref":"AshJsonApi.ToJsonApiError.html#to_json_api_error/1"},{"type":"module","title":"AshJsonApi.Domain.BaseRoute","doc":"Introspection target for base routes in `AshJsonApi.Domain`","ref":"AshJsonApi.Domain.BaseRoute.html"},{"type":"module","title":"AshJsonApi.Domain.Verifiers.VerifyActions","doc":"Verifies that all actions are valid for each route.","ref":"AshJsonApi.Domain.Verifiers.VerifyActions.html"},{"type":"module","title":"AshJsonApi.Domain.Verifiers.VerifyHasType","doc":"Verifies that a resource has a type if it has any routes that need it.","ref":"AshJsonApi.Domain.Verifiers.VerifyHasType.html"},{"type":"module","title":"AshJsonApi.Domain.Verifiers.VerifyQueryParams","doc":"Verify query params are not reserved or shadowed by the route","ref":"AshJsonApi.Domain.Verifiers.VerifyQueryParams.html"},{"type":"module","title":"AshJsonApi.Domain.Verifiers.VerifyRelationships","doc":"Verifies that any routes that reference a relationship reference a public one","ref":"AshJsonApi.Domain.Verifiers.VerifyRelationships.html"},{"type":"function","title":"AshJsonApi.Domain.Verifiers.VerifyRelationships.verify/1","doc":"Callback implementation for  Spark.Dsl.Verifier.verify/1 .","ref":"AshJsonApi.Domain.Verifiers.VerifyRelationships.html#verify/1"},{"type":"module","title":"AshJsonApi.Igniter","doc":"Codemods and utilities for working with AshJsonApi & Igniter","ref":"AshJsonApi.Igniter.html"},{"type":"function","title":"AshJsonApi.Igniter.ash_json_api_routers/1","doc":"Returns all modules that `use AshJsonApi.Router`","ref":"AshJsonApi.Igniter.html#ash_json_api_routers/1"},{"type":"function","title":"AshJsonApi.Igniter.find_ash_json_api_router/2","doc":"Returns the AshJsonApi router containing the domain in question, or a list of all AshJsonApi schemas","ref":"AshJsonApi.Igniter.html#find_ash_json_api_router/2"},{"type":"function","title":"AshJsonApi.Igniter.setup_ash_json_api_router/2","doc":"Sets up an `AshJsonApi.Router` for AshJsonApi","ref":"AshJsonApi.Igniter.html#setup_ash_json_api_router/2"},{"type":"function","title":"AshJsonApi.Igniter.setup_phoenix/2","doc":"Sets up the phoenix module for AshJsonApi","ref":"AshJsonApi.Igniter.html#setup_phoenix/2"},{"type":"function","title":"AshJsonApi.Igniter.setup_routes_alias/1","doc":"","ref":"AshJsonApi.Igniter.html#setup_routes_alias/1"},{"type":"module","title":"AshJsonApi.Plug.Parser","doc":"Extracts ash multipart request body.\n\nFor use with `Plug.Parsers`, as in the example below.","ref":"AshJsonApi.Plug.Parser.html"},{"type":"module","title":"Examples - AshJsonApi.Plug.Parser","doc":"Should be used with `Plug.Parsers`:\n\n    plug Plug.Parsers,\n      parsers: [:urlencoded, :multipart, :json, AshJsonApi.Plug.Parser],\n      pass: [\"*/*\"],\n      json_decoder: Jason","ref":"AshJsonApi.Plug.Parser.html#module-examples"},{"type":"module","title":"Protocol - AshJsonApi.Plug.Parser","doc":"To use files in your request, send a\n[multipart](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types#multipart)\nwith the content type `multipart/x.ash+form-data`. The request MUST\ncontain a JSON object with the key `data` and the value of the object you want\nto send.\n\nThe request MAY contain other keys with the value of the file you want to\nsend. The parser will walk through all of the `data` JSON and replace each\nstring equal to a part name with the content of the part. This means that if\nyou have a part named `users_csv` and a key in the `data` JSON object with the\nvalue `users_csv`, the parser will replace the string with the content of the\npart.\n\n> #### Conflicting Part names {:.warning}\n>\n> Ensure that each part name is unique and does not naturally occur inside as\n> a string in the `data` JSON object. If a part name is found in the `data`\n> JSON object, the parser will replace it with the content of the part.\n>\n> It is recommended to use a unique value like a UUID as the part name.","ref":"AshJsonApi.Plug.Parser.html#module-protocol"},{"type":"module","title":"Example HTTP Message - AshJsonApi.Plug.Parser","doc":"```\nPOST /action\nHost: example.com\nContent-Length: 2740\nContent-Type: multipart/x.ash+form-data; boundary=abcde12345\n--abcde12345\nContent-Disposition: form-data; name=\"data\"\nContent-Type: application/vnd.api+json\n\n{\"users\": \"users_csv\", \"meatdata\": \"metadata_json\"}\n--abcde12345\nContent-Disposition: form-data; name=\"users_csv\"; filename=\"users.csv\"\nContent-Type: text/csv\n\n[file content goes here]\n--abcde12345\nContent-Disposition: form-data; name=\"metadata_json\"; filename=\"metadata.json\"\nContent-Type: application/json\n\n[file content goes there]\n--abcde12345--\n```","ref":"AshJsonApi.Plug.Parser.html#module-example-http-message"},{"type":"module","title":"AshJsonApi.Resource.Verifiers.VerifyActions","doc":"Verifies that all actions are valid for each route.","ref":"AshJsonApi.Resource.Verifiers.VerifyActions.html"},{"type":"module","title":"AshJsonApi.Resource.Verifiers.VerifyHasType","doc":"Verifies that a resource has a type if it has any routes that need it.","ref":"AshJsonApi.Resource.Verifiers.VerifyHasType.html"},{"type":"module","title":"AshJsonApi.Resource.Verifiers.VerifyIncludes","doc":"Verifies that all includes are valid public relationships","ref":"AshJsonApi.Resource.Verifiers.VerifyIncludes.html"},{"type":"module","title":"AshJsonApi.Resource.Verifiers.VerifyQueryParams","doc":"Verify query params are not reserved or shadowed by the route","ref":"AshJsonApi.Resource.Verifiers.VerifyQueryParams.html"},{"type":"module","title":"AshJsonApi.Resource.Verifiers.VerifyRelationships","doc":"Verifies that any routes that reference a relationship reference a public one","ref":"AshJsonApi.Resource.Verifiers.VerifyRelationships.html"},{"type":"function","title":"AshJsonApi.Resource.Verifiers.VerifyRelationships.verify/1","doc":"Callback implementation for  Spark.Dsl.Verifier.verify/1 .","ref":"AshJsonApi.Resource.Verifiers.VerifyRelationships.html#verify/1"},{"type":"behaviour","title":"AshJsonApi.Type","doc":"The behaviour for customizing how a datatype is rendered and written in AshJsonApi.","ref":"AshJsonApi.Type.html"},{"type":"callback","title":"AshJsonApi.Type.json_schema/1","doc":"","ref":"AshJsonApi.Type.html#c:json_schema/1"},{"type":"callback","title":"AshJsonApi.Type.json_write_schema/1","doc":"","ref":"AshJsonApi.Type.html#c:json_write_schema/1"},{"type":"task","title":"mix ash_json_api.install","doc":"Installs AshJsonApi. Should be run with `mix igniter.install ash_json_api`","ref":"Mix.Tasks.AshJsonApi.Install.html"},{"type":"function","title":"Mix.Tasks.AshJsonApi.Install.igniter/1","doc":"Callback implementation for  Igniter.Mix.Task.igniter/1 .","ref":"Mix.Tasks.AshJsonApi.Install.html#igniter/1"},{"type":"task","title":"mix ash_json_api.routes","doc":"Prints all routes pertaining to AshJsonApi.Router for the default or a given router.\n\nThis task can be called directly, accepting the same options as `mix phx.routes`, except for `--info`.\n\nAccepts option `--json_router` to specify your Ash Json Router. Defaults to `YourAppWeb.AshJsonApiRouter`.\n\nAlternatively, you can modify your aliases task to run them back to back it.\n\n```elixir\naliases: [\"phx.routes\": [\"do\", \"phx.routes,\", \"ash_json_api.routes\"]]\n```","ref":"Mix.Tasks.AshJsonApi.Routes.html"},{"type":"function","title":"Mix.Tasks.AshJsonApi.Routes.get_url_info/2","doc":"","ref":"Mix.Tasks.AshJsonApi.Routes.html#get_url_info/2"},{"type":"extras","title":"Home","doc":"![Logo](https://github.com/ash-project/ash/blob/main/logos/cropped-for-header-black-text.png?raw=true#gh-light-mode-only)\n![Logo](https://github.com/ash-project/ash/blob/main/logos/cropped-for-header-white-text.png?raw=true#gh-dark-mode-only)\n\n![Elixir CI](https://github.com/ash-project/ash_json_api/workflows/CI/badge.svg)\n[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)\n[![Hex version badge](https://img.shields.io/hexpm/v/ash_json_api.svg)](https://hex.pm/packages/ash_json_api)\n[![Hexdocs badge](https://img.shields.io/badge/docs-hexdocs-purple)](https://hexdocs.pm/ash_json_api)\n\n# AshJsonApi\n\nWelcome! This is the extension for building [JSON:API](https://jsonapi.org) spec compliant APIs with [Ash](https://hexdocs.pm/ash). Generate a powerful JSON API in minutes!","ref":"readme.html"},{"type":"extras","title":"Tutorials - Home","doc":"- [Getting Started with AshJsonApi](documentation/tutorials/getting-started-with-ash-json-api.md)","ref":"readme.html#tutorials"},{"type":"extras","title":"Topics - Home","doc":"- [What is AshJsonApi?](documentation/topics/what-is-ash-json-api.md)\n- [Non-Spec Query Parameters](documentation/topics/non-spec-query-parameters.md)\n- [OpenAPI](documentation/topics/open-api.md)\n- [Relationships](documentation/topics/relationships.md)\n- [Authorize With AshJsonApi](documentation/topics/authorize-with-json-api.md)\n- [Upgrading to 1.0](documentation/topics/upgrade.md)","ref":"readme.html#topics"},{"type":"extras","title":"Reference - Home","doc":"- [AshJsonApi.Resource DSL](documentation/dsls/DSL-AshJsonApi.Resource.md)\n- [AshJsonApi.Domain DSL](documentation/dsls/DSL-AshJsonApi.Domain.md)","ref":"readme.html#reference"},{"type":"extras","title":"Getting started with AshJsonApi","doc":"# Getting started with AshJsonApi","ref":"getting-started-with-ash-json-api.html"},{"type":"extras","title":"Installing AshJsonApi - Getting started with AshJsonApi","doc":"<!-- tabs-open -->","ref":"getting-started-with-ash-json-api.html#installing-ashjsonapi"},{"type":"extras","title":"Using Igniter (recommended) - Getting started with AshJsonApi","doc":"```sh\nmix igniter.install ash_json_api\n```","ref":"getting-started-with-ash-json-api.html#using-igniter-recommended"},{"type":"extras","title":"Manually - Getting started with AshJsonApi","doc":"This manual setup branches off from the [Getting Started with Ash](https://hexdocs.pm/ash/get-started.html) guide.\nIf you aren't starting from there, replace the application name, `Helpdesk`, with your application name,\nand replace the `Ash.Domain` name, `Helpdesk.Support` with a domain or domains from your own application.\n\n#### Add the ash_json_api dependency\n\nIn your mix.exs, add the Ash JSON API dependency:\n\n```elixir\n  defp deps do\n    [\n      # .. other dependencies\n      {:ash_json_api, \"~> 1.0\"},\n    ]\n  end\n```\n\n#### Accept json_api content type\n\nAdd the following to your `config/config.exs`.\n\n```elixir\n# config/config.exs\nconfig :mime,\n  extensions: %{\"json\" => \"application/vnd.api+json\"},\n  types: %{\"application/vnd.api+json\" => [\"json\"]}\n```\n\nThis configuration is required to support working with the JSON:API custom mime type.\n\nAfter adding the configuration above, compiling the project might throw an error:\n\n```\nERROR! the application :mime has a different value set for key :types during runtime compared to compile time.\n```\n\nThis can happen if `:mime` was already compiled before the configuration was changed and can be\nfixed by running\n\n```\nmix deps.compile mime --force\n```\n\n#### Create a router\n\nCreate a separate Router Module to work with your Domains. It will generate the routes for\nyour Resources and provide the functions you would usually have in a Controller.\n\nWe will later forward requests from your Applications primary (Phoenix) Router to you Ash JSON API Router.\n\n```elixir\ndefmodule HelpdeskWeb.JsonApiRouter do\n  use AshJsonApi.Router,\n    # The api modules you want to serve\n    domains: [Helpdesk.Support],\n    # optionally an open_api route\n    open_api: \"/open_api\"\nend\n```\n\nAdditionally, your Resource requires a type, a base route and a set of allowed HTTP methods and what action they will trigger.\n\n#### Add `AshJsonApi.Plug.Parser` to your endpoint\n\nThis handles any file uploads, if you have resource actions with the `:file` type.\n\n```elixir\nplug Plug.Parsers,\n  parsers: [:urlencoded, :multipart, :json, AshJsonApi.Plug.Parser], # <- add it to this list.\n  pass: [\"*/*\"],\n  json_decoder: Jason\n```\n\nYou don't have to add this if you don't plan on doing any file uploads, but\nthere is no cost to adding it, even if you don't use it.\n\n#### Add the routes from your domain module(s)\n\nTo make your Resources accessible to the outside world, forward requests from your Phoenix router to the router you created for your domains.\n\nFor example:\n\n```elixir\nscope \"/api/json\" do\n  pipe_through(:api)\n\n  forward \"/helpdesk\", HelpdeskWeb.JsonApiRouter\nend\n```\n\n<!-- tabs-close -->","ref":"getting-started-with-ash-json-api.html#manually"},{"type":"extras","title":"Configure your Resources and Domain and expose actions - Getting started with AshJsonApi","doc":"These examples are based off of the [Getting Started with Ash](https://hexdocs.pm/ash/get-started.html) guide.","ref":"getting-started-with-ash-json-api.html#configure-your-resources-and-domain-and-expose-actions"},{"type":"extras","title":"Add the AshJsonApi extension to your domain and resource - Getting started with AshJsonApi","doc":"<!-- tabs-open -->","ref":"getting-started-with-ash-json-api.html#add-the-ashjsonapi-extension-to-your-domain-and-resource"},{"type":"extras","title":"Using Igniter (recommended) - Getting started with AshJsonApi","doc":"To set up an existing resource of your own with `AshJsonApi`, run:\n\n```sh\nmix ash.patch.extend Your.Resource.Name json_api\n```","ref":"getting-started-with-ash-json-api.html#using-igniter-recommended-1"},{"type":"extras","title":"Manually - Getting started with AshJsonApi","doc":"Add to your domain:\n\n```elixir\ndefmodule Helpdesk.Support do\n  use Ash.Domain, extensions: [AshJsonApi.Domain]\n  ...\n```\n\nAnd to your resource:\n\n```elixir\ndefmodule Helpdesk.Support.Ticket do\n  use Ash.Resource, extensions: [AshJsonApi.Resource]\n  # ...\n  json_api do\n    type \"ticket\"\n  end\nend\n```\n\n<!-- tabs-close -->","ref":"getting-started-with-ash-json-api.html#manually-1"},{"type":"extras","title":"Define Routes - Getting started with AshJsonApi","doc":"Routes can be defined on the resource or the domain. If you define them on the domain (which is our default recommendation), the resource in question must still use the `AshJsonApi.Resource` extension, and define its own type.","ref":"getting-started-with-ash-json-api.html#define-routes"},{"type":"extras","title":"Defining routes on the domain - Getting started with AshJsonApi","doc":"```elixir\ndefmodule Helpdesk.Support do\n  use Ash.Domain, extensions: [AshJsonApi.Domain]\n\n  json_api do\n    routes do\n      # in the domain `base_route` acts like a scope\n      base_route \"/tickets\", Helpdesk.Support.Ticket do\n        get :read\n        index :read\n        post :open\n      end\n    end\n  end\nend\n```\n\nAnd then add the extension and type to the resource:\n\n```elixir\ndefmodule Helpdesk.Support.Ticket do\n  use Ash.Resource, extensions: [AshJsonApi.Resource]\n  # ...\n  json_api do\n    type \"ticket\"\n  end\nend\n```","ref":"getting-started-with-ash-json-api.html#defining-routes-on-the-domain"},{"type":"extras","title":"Defining routes on the resource - Getting started with AshJsonApi","doc":"Here we show an example of defining routes on the resource.\n\n```elixir\ndefmodule Helpdesk.Support.Ticket do\n  use Ash.Resource, extensions: [AshJsonApi.Resource]\n  # ...\n  json_api do\n    type \"ticket\"\n\n    routes do\n      # on the resource, the `base` applies to all routes\n      base \"/tickets\"\n\n      get :read\n      index :read\n      post :open\n      # ...\n    end\n  end\nend\n```\n\nCheck out the [AshJsonApi.Resource documentation on\nHex](https://hexdocs.pm/ash_json_api/AshJsonApi.Resource.html) for more information.","ref":"getting-started-with-ash-json-api.html#defining-routes-on-the-resource"},{"type":"extras","title":"Run your API - Getting started with AshJsonApi","doc":"From here on out its the standard Phoenix behavior. Start your application with `mix phx.server`\nand your API should be ready to try out. Should you be wondering what routes are available, you can\nprint all available routes for each Resource:\n\n```elixir\nHelpdesk.Support.Ticket\n|> AshJsonApi.Resource.Info.routes(Helpdesk.Support)\n```\n\nMake sure that all requests you make to the API use the `application/vnd.api+json` type in both the\n`Accept` and `Content-Type` (where applicable) headers. The `Accept` header may be omitted.\n\nExamples:\n\n1. Create a ticket\n   ```bash\n   curl -X POST 'localhost:4000/api/json/helpdesk/tickets' \\\n   --header 'Accept: application/vnd.api+json' \\\n   --header 'Content-Type: application/vnd.api+json' \\\n   --data-raw '{\n     \"data\": {\n       \"type\": \"ticket\",\n       \"attributes\": {\n         \"subject\": \"This ticket was created through the JSON API\"\n       }\n     }\n   }'\n   ```\n1. Get all tickets\n   ```bash\n   curl 'localhost:4000/api/json/helpdesk/tickets'\n   ```\n1. Get a specific ticket\n   ```bash\n   # Add the uuid of a Ticket you created earlier\n   curl 'localhost:4000/api/json/helpdesk/tickets/ '\n   ```","ref":"getting-started-with-ash-json-api.html#run-your-api"},{"type":"extras","title":"Open API - Getting started with AshJsonApi","doc":"If you want to expose your API via Swagger UI or Redoc, see [the open api documentation](/documentation/topics/open-api.md).","ref":"getting-started-with-ash-json-api.html#open-api"},{"type":"extras","title":"What is AshJsonApi","doc":"# What is AshJsonApi\n\nAshJsonApi allows you to expose your resource actions over a [JSON:API](https://jsonapi.org]). This API supports all of the features of JSON:API and Ash, like sorting, filtering, pagination, and side loading.\n\nThe kinds of thing this extension handles:\n\n1. Route Creation: AshJsonApi defines routes and actions in your app based on resource configurations\n2. Deserialization: When an incoming HTTP request hits a AshJsonApi defined route/action, AshJsonApi will parse it from `/api/users?filter[admin]=true` into a call to ash\n3. Query Execution: AshJsonApi then executes the parsed Ash Action (this is the integration point between AshJsonApi and Ash Core, where Ash Actions are defined)\n4. Serialization: AshJsonApi then serializes the result of the Ash Action into JSON API objects.\n5. Response: AshJsonApi then sends this JSON back to the client\n6. Schema Generation: AshJsonApi generates a machine-readable JSON Schema of your entire API and a route/action that can serve it\n7. OpenAPI generation: AshJsonApi generates an OpenAPI spec for your API, which provides _human_ readable documentation effortlessly.\n\n>","ref":"what-is-ash-json-api.html"},{"type":"extras","title":"Ash does the work - What is AshJsonApi","doc":">\n> Ash takes care of all of the data related work for a request (CRUD, Sorting, Filtering, Pagination, Side Loading, and Authorization) while AshJsonApi more or less replaces controllers and serializers.\n>\n> The beauty of putting all of that data functionality into a non-web layer (Ash) is that it can be used in many contexts. A JSON:API is one context - but there are others such as GraphQL or just using an Ash Resource from other code within an Application.","ref":"what-is-ash-json-api.html#ash-does-the-work"},{"type":"extras","title":"Non-Spec query parameters","doc":"# Non-Spec query parameters\n\nAshJsonApi supports a few non-spec query parameters that enhance\nthe capabilities of your API.\n\nThese are currently not exposed in the generated OpenAPI spec. PRs welcome!\n\n## `filter_included`\n\nIncludes can be filtered via the `filter_included` query parameter.\nTo do this, you provide the path to the included resource and the\nfilter to apply.\n\nExample:\n\n`posts?include=comments&filter_included[comments][author_id]=1`\n\n\n## `sort_included`\n\nIncludes can be sorted via the `sort_included` query parameter.\nTo do this, you provide the path to the included resource and the\nsort to apply.\n\nExample:\n\n`posts?include=comments&sort_included[comments]=author.username,-created_at`\n\n>","ref":"non-spec-query-parameters.html"},{"type":"extras","title":"included is unsorted! - Non-Spec query parameters","doc":">\n> Keep in mind that the records in the top level `included` key will not be\n> reliably sorted. This is because multiple relationships could include the same record.\n> When sorting includes, look at the `data.relationships.name` key for the order instead.\n\n## `field_inputs`\n\nThe `field_inputs` parameter allows you to pass values to calculations that require user input.\nThis is particularly useful when you need to provide context-specific values for dynamic calculations.\n\nThe syntax follows this pattern:\n`field_inputs[resource_type][calculation_name][parameter_name]=value`\n\nYou can use this in combination with sparse fieldsets to request specific calculations:\n\nExample:\n\n`blogs?fields[blog]=title,views,monthly_engagement&field_inputs[blog][monthly_engagement][yyyy_mm]=2024.06`\n\nThis would request the `title`, `views`, and `monthly_engagement` attributes for blogs, while providing \nthe input parameter `yyyy_mm` with value `2024.06` to the `monthly_engagement` calculation.\n\nWhen you need to provide input for multiple calculations or multiple parameters, specify each `field_inputs` parameter in its full form:\n\n`blogs?fields[blog]=title,views,monthly_engagement,quarterly_stats&field_inputs[blog][monthly_engagement][yyyy_mm]=2024.06&field_inputs[blog][quarterly_stats][quarter]=Q2&field_inputs[blog][quarterly_stats][year]=2024`","ref":"non-spec-query-parameters.html#included-is-unsorted"},{"type":"extras","title":"Open API","doc":"# Open API","ref":"open-api.html"},{"type":"extras","title":"Use with Phoenix - Open API","doc":"To set up the Open API endpoints for your application, first include the `:open_api_spex` dependency:\n\n```elixir\n{:open_api_spex, \"~> 3.16\"},\n```\n\nThen in the module where you call `use AshJsonApi.Router` add the following option:\n\n```elixir\nuse AshJsonApi.Router, domains: [...], open_api: \"/open_api\"\n```\n\nFinally, you can use utilities provided by `open_api_spex` to show UIs for your API. Be sure to put your `forward` call last, if you are putting your API at a sub-path.\n\n```elixir\nforward \"/api/swaggerui\",\n  OpenApiSpex.Plug.SwaggerUI,\n  path: \"/api/open_api\",\n  default_model_expand_depth: 4\n\nforward \"/api/redoc\",\n  Redoc.Plug.RedocUI,\n  spec_url: \"/api/open_api\"\n\nforward \"/api\", YourApp.YourApiRouter\n```\n\nNow you can go to `/api/swaggerui` and `/api/redoc`!","ref":"open-api.html#use-with-phoenix"},{"type":"extras","title":"Use with Plug - Open API","doc":"To set up the open API endpoints for your application, first include the `:open_api_spex` and `:redoc_ui_plug` dependency:\n\n```elixir\n{:open_api_spex, \"~> 3.16\"},\n{:redoc_ui_plug, \"~> 0.2.1\"},\n```\n\nThen in the module where you call `use AshJsonApi.Router` add the following option:\n\n```elixir\nuse AshJsonApi.Router, domains: [...], open_api: \"/open_api\"\n```\n\nFinally, you can use utilities provided by `open_api_spex` to show UIs for your API. Be sure to put your `forward` call last, if you are putting your API at a sub-path.\n\n```elixir\nforward \"/api/swaggerui\",\n  to: OpenApiSpex.Plug.SwaggerUI,\n  init_opts: [\n    path: \"/api/open_api\",\n    default_model_expand_depth: 4\n  ]\n\nforward \"/api/redoc\",\n  to: Redoc.Plug.RedocUI,\n  init_opts: [\n    spec_url: \"/api/open_api\"\n  ]\n\nforward \"/api\", YourApp.YourApiRouter\n```\n\nNow you can go to `/api/swaggerui` and `/api/redoc`!","ref":"open-api.html#use-with-plug"},{"type":"extras","title":"Customize values in the OpenAPI documentation - Open API","doc":"To customize the main values of the OpenAPI spec, a few options are available:\n\n```elixir\n  use AshJsonApi.Router,\n    domains: [...],\n    open_api: \"/open_api\",\n    open_api_title: \"Title\",\n    open_api_version: \"1.0.0\",\n    open_api_servers: [\"http://domain.com/api/v1\"]\n```\n\nIf `:open_api_servers` is not specified, a default server is automatically derived from your app's Phoenix endpoint, as retrieved from inbound connections on the `open_api` HTTP route.\n\nIn case an active connection is not available, for example when generating the OpenAPI spec via CLI, you can explicitely specify a reference to the Phoenix endpoint:\n\n```elixir\n  use AshJsonApi.Router,\n    domains: [...],\n    open_api: \"/open_api\",\n    phoenix_endpoint: MyAppWeb.Endpoint\n```\n\nTo override any value in the OpenApi documentation you can use the `:modify_open_api` options key:\n\n```elixir\n  use AshJsonApi.Router,\n    domains: [...],\n    open_api: \"/open_api\",\n    modify_open_api: {__MODULE__, :modify_open_api, []}\n\n  def modify_open_api(spec, _, _) do\n    %{\n      spec\n      | info: %{spec.info | title: \"MyApp Title JSON API\", version: Application.spec(:my_app, :vsn) |> to_string()}\n    }\n  end\n```","ref":"open-api.html#customize-values-in-the-openapi-documentation"},{"type":"extras","title":"Generate spec files via CLI - Open API","doc":"You can write the OpenAPI spec file to disk using the Mix tasks provided by [OpenApiSpex](https://github.com/open-api-spex/open_api_spex).\n\nSupposing you have setup AshJsonApi as:\n\n```elixir\ndefmodule MyAppWeb.AshJsonApi\n  use AshJsonApi.Router, domains: [...], open_api: \"/open_api\"\nend\n```\n\nyou can generate the files with:\n\n```sh\nmix openapi.spec.json --spec MyAppWeb.AshJsonApi\nmix openapi.spec.yaml --spec MyAppWeb.AshJsonApi\n```\n\n>","ref":"open-api.html#generate-spec-files-via-cli"},{"type":"extras","title":"Setting a route prefix for generated files - Open API","doc":">\n> The route prefix in normal usage is automatically inferred, but when generating files\n> we will use the `prefix` option set in the `json_api` section of the relevant `Ash.Domain` module.\n\nTo generate the YAML file you need to add the ymlr dependency.\n\n```elixir\ndef deps do\n  [\n    {:ymlr, \"~> 2.0\"}\n  ]\nend\n```\n\nYou can also use the `--check` option to confirm that your checked in spec file(s) match.\n\n```sh\nmix openapi.spec.json --spec MyAppWeb.AshJsonApiRouter --check\nmix openapi.spec.yaml --spec MyAppWeb.AshJsonApiRouter --check\n```","ref":"open-api.html#setting-a-route-prefix-for-generated-files"},{"type":"extras","title":"Using this file in production - Open API","doc":"To avoid generating the spec every time your open_api endpoint is hit, you can use\nthe `open_api_file` option. Ensure that it points to an existing `.json` file.\nYou will almost certainly want to do this only for production so that the schema\nis generated dynamically in dev, but served statically in production.\n\n```elixir\nopen_api_file =\n  if Mix.env() == :prod do\n    \"priv/static/open_api.json\"\n  else\n    nil\n  end\n\nuse AshJsonApi.Router,\n  domains: [...],\n  open_api: \"/open_api\",\n  modify_open_api: {__MODULE__, :modify_open_api, []},\n  open_api_file: open_api_file\n```","ref":"open-api.html#using-this-file-in-production"},{"type":"extras","title":"Known issues/limitations - Open API","doc":"","ref":"open-api.html#known-issues-limitations"},{"type":"extras","title":"Swagger UI - Open API","doc":"SwaggerUI does not properly render recursive types. This affects the examples and type documentation for the `filter` parameter especially.","ref":"open-api.html#swagger-ui"},{"type":"extras","title":"Redoc - Open API","doc":"Redoc does not show all available schemas in the sidebar. This means that some schemas that are referenced only but have no endpoints that refer to them are effectively un-discoverable without downloading the spec and hunting them down yourself.","ref":"open-api.html#redoc"},{"type":"extras","title":"Relationships","doc":"# Relationships\n\nYou can specify which arguments will modify relationships using `relationship_arguments`, but there are some things to keep in mind.\n\n`relationship_arguments` is a list of arguments that can be edited in the `data.relationships` input.\n\nThis is primarily useful for those who want to keep their relationship changes in compliance with the `JSON:API` spec.\nIf you are not focused on building a fully compliant JSON:API, it is likely far simpler to simply accept arguments\nin the `attributes` key and ignore the `data.relationships` input.\n\nIf the argument's type is `{:array, _}`, a list of data will be expected. Otherwise, it will expect a single item.\n\nEverything in this guide applies to routs defined on the domain as well.\n\nFor example:\n\n```elixir\n# On a tweets resource\n\n# With a patch route that references the `authors` argument\njson_api do\n  routes do\n    patch :update, relationship_arguments: [:authors]\n  end\nend\n\n# And an argument by that name in the action\nactions do\n  update :update do\n    argument :authors, {:array, :map}, allow_nil?: false\n\n    change manage_relationship(:authors, type: :append_and_remove) # Use the authors argument to allow changing the related authors on update\n  end\nend\n```\n\nYou can then send the value for `authors` in the relationships key, e.g\n\n```json\n{\n  data: {\n    attributes: {\n      ...\n    },\n    relationships: {\n      authors: {\n        data: [\n          {type: \"author\", id: 1}, // the `type` key is removed when the value is placed into the action, so this input would be `%{\"id\" => 1}` (`type` is required by `JSON:API` specification)\n          {type: \"author\", id: 2, meta: {arbitrary: 1, keys: 2}}, <- `meta` is JSON:API spec freeform data, so this input would be `%{\"id\" => 2, \"arbitrary\" => 1, \"keys\" => 2}`\n        ]\n      }\n    }\n  }\n}\n```\n\nIf you do not include `:authors` in the `relationship_arguments` key, you would supply its value in `attributes`, e.g:\n\n```elixir\n{\n  data: {\n    attributes: {\n      authors: {\n        {id: 1},\n        {id: 2, arbitrary: 1, keys: 2},\n      }\n    }\n  }\n}\n```\n\nNon-map argument types, e.g `argument :author, :integer` (expecting an author id) work with `manage_relationship`, but not with\nJSON:API, because it expects `{\"type\": _type, \"id\" => id}` for relationship values. To support non-map arguments in `relationship_arguments`,\ninstead of `:author`, use `{:id, :author}`. This works for `{:array, _}` type arguments as well, so the value would be a list of ids.","ref":"relationships.html"},{"type":"extras","title":"Relationship Manipulation Routes - Relationships","doc":"You can also specify routes that are dedicated to manipulating relationships. We generally suggest the above approach, but JSON:API spec also allows for dedicated relationship routes. For example:\n\n```elixir\nroutes do\n  ...\n  # use `post_to_relationship` when the operation is additive\n  post_to_relationship :add_author, action: :add_author\n  # use `patch_relationship` when the operation is both additive and subtractive\n  # use `delete_from_relationship` when the operation is subtractive\nend\n```\n\nThis will use an action on the source resource, (by default the primary update), and expects it to take an argument with the corresponding name. Additionally, it must have a `change manage_relationship` that uses that attribute. For example:\n\n```elixir\nupdate :add_author do\n  argument :author, :map\n\n  change manage_relationship(:author, type: :append)\nend\n```","ref":"relationships.html#relationship-manipulation-routes"},{"type":"extras","title":"Links","doc":"# Links\n\nIn JSON:API, there are various pre-specified links.","ref":"links.html"},{"type":"extras","title":"Self links to routes - Links","doc":"Whenever you hit a route, there will be a `self` link in the top-level `links` object that points to the current request url.","ref":"links.html#self-links-to-routes"},{"type":"extras","title":"Pagination links on index routes - Links","doc":"There will be `first`, `last`, `prev`, and `next` links on paginatable index routes, allowing clients to navigate through the pages of results.","ref":"links.html#pagination-links-on-index-routes"},{"type":"extras","title":"Self links on individual entities - Links","doc":"In order to get a self link generated for an individual entity, you must designate one of your `get` routes as `primary? true`. For example:\n\n```elixir\nget :read, primary?: true\n```\n\nThen, each entity will have a `self` link in its `links` key.","ref":"links.html#self-links-on-individual-entities"},{"type":"extras","title":"Related links - Links","doc":"","ref":"links.html#related-links"},{"type":"extras","title":"Relationship Self Links - Links","doc":"Relationship self links are links to endpoints that return only the linkage, _not_ the actual data of the related entities. To generate a relationship self link for a relationship, mark one of your `relationship` routes as `primary? true`. For example:\n\n```elixir\nrelationship :comments, :read, primary?: true\n```","ref":"links.html#relationship-self-links"},{"type":"extras","title":"Relationship Related Links - Links","doc":"Relationship _related_ links, on the other hand, are endpoints that return the related entities themselves, acting as modified index routes over the destination of the relationship. To generate one of these, mark one of your `related` routes as `primary? true`. For example:\n\n```elixir\nrelated :comments, :read, primary?: true\n```","ref":"links.html#relationship-related-links"},{"type":"extras","title":"Upgrading to AshJsonApi to 1.0","doc":"# Upgrading to AshJsonApi to 1.0\n\nTwo major things have changed in `AshJsonApi` 1.0.","ref":"upgrade.html"},{"type":"extras","title":"Errors - Upgrading to AshJsonApi to 1.0","doc":"The error handling has been revamped to be more in line with patterns around Ash and AshGraphql. To implement custom errors, or to enable additional Ash errors to be displayed by AshJsonApi, you will implement the `AshJsonApi.ToJsonApiError` protocol. Here is how its done for one of the builtin errors:\n\n```elixir\ndefimpl AshJsonApi.ToJsonApiError, for: Ash.Error.Changes.InvalidChanges do\n  def to_json_api_error(error) do\n    %AshJsonApi.Error{\n      id: Ash.UUID.generate(),\n      status_code: AshJsonApi.Error.class_to_status(error.class),\n      code: \"invalid\",\n      title: \"Invalid\",\n      source_parameter: to_string(error.field),\n      detail: error.message,\n      meta: Map.new(error.vars)\n    }\n  end\nend\n```","ref":"upgrade.html#errors"},{"type":"extras","title":"Relationship Routes - Upgrading to AshJsonApi to 1.0","doc":"Previously, AshJsonApi called `Ash.Changeset.manage_relationship` on the changeset built for the action. Now, _you_ have to define the argument and manage_relationship yourself. See the relationships guide for more.\n\n## `Ash.Api` is now `Ash.Domain` in Ash 3.0\n\nYour Router module file (the module that has `use AshJsonApi.Router` in it) will need all references to `api` updated to be `domain`. eg.\n\n```elixir\ndefmodule MyApp.MyApi.Router do\n  use AshJsonApi.Router,\n    domains: [MyApp.Domain1, MyApp.Domain2],\n    ...\n```","ref":"upgrade.html#relationship-routes"},{"type":"extras","title":"Authorize with AshJsonApi","doc":"# Authorize with AshJsonApi\n\nBy default, `authorize?` in the domain is set to true. To disable authorization entirely for a given domain in json_api, use:\n\n```elixir\njson_api do\n  authorize? false\nend\n```\n\nThis is typically only necessary for testing purposes.\n\nIf you are doing authorization, you'll need to provide an `actor`.","ref":"authorize-with-json-api.html"},{"type":"extras","title":"Setting the actor manually - Authorize with AshJsonApi","doc":"If you are using AshAuthentication, this will be done for you. To set the `actor` for authorization, you'll need to add an `actor` key to the\n`conn`. Typically, you would have a plug that fetches the current user and uses `Ash.PlugHelpers.set_actor/2` to set the actor in the `conn` (likewise with `Ash.PlugHelpers.set_tenant/2`).\n\n```elixir\ndefmodule MyAppWeb.Router do\n  pipeline :api do\n    # ...\n    plug :get_actor_from_token\n  end\n\n  def get_actor_from_token(conn, _opts) do\n     with [\"\" <> token] <- get_req_header(conn, \"authorization\"),\n         {:ok, user, _claims} <- MyApp.Guardian.resource_from_token(token) do\n      conn\n      |> Ash.PlugHelpers.set_actor(user)\n    else\n    _ -> conn\n    end\n  end\nend\n```","ref":"authorize-with-json-api.html#setting-the-actor-manually"},{"type":"extras","title":"Authenticating with AshJsonApi","doc":"# Authenticating with AshJsonApi\n\nAuthenticating with AshJsonApi requires a few things. The first thing to note is that this is not something that is provided for you out of the box by `ash_authentication`.\n\nYou will need to:\n\n- connect the authentication action to a route manually\n- need to extract the resulting authentication token\n- set it as a header or as metadata to provide it to the client to use on future requests\n\nYou may also need to add a policy bypass to your resource, to make the action accessible via a non-AshAuthenticationPhoenix liveview.","ref":"authenticate-with-json-api.html"},{"type":"extras","title":"The route - Authenticating with AshJsonApi","doc":"In this example, we will use the standard `:sign_in_with_password` action that is created by `ash_authentication` under the hood, and we will return the token as part of the response metadata.\n\n```elixir\n# In your User module\ndefmodule  . .User do\n  json_api do\n    routes do\n      # Read actions that return *only one resource* are allowed to be used with\n      # `post` routes.\n      post :sign_in_with_password do\n        route \"/sign_in\"\n\n        # Given a successful request, we will modify the response to include the\n        # generated token\n        metadata fn _subject, user, _request ->\n          %{token: user.__metadata__.token}\n        end\n      end\n    end\n  end\nend\n```\n\nThis will add the token to the `meta` key in a successful API response, eg.\n\n```json\n{\n  {\n  \"data\": {\n    \"attributes\": { ... },\n    ...\n  },\n  \"meta\": {\n    \"token\": \"eyJhbGc...\"\n  }\n}\n```","ref":"authenticate-with-json-api.html#the-route"},{"type":"DSL","title":"json_api - dsl-ashjsonapi-resource","doc":"Configure the resource's behavior in the JSON:API","ref":"dsl-ashjsonapi-resource.html#json_api"},{"type":"DSL","title":"json_api.type - dsl-ashjsonapi-resource","doc":"The resource identifier type of this resource in JSON:API","ref":"dsl-ashjsonapi-resource.html#json_api-type"},{"type":"DSL","title":"json_api.includes - dsl-ashjsonapi-resource","doc":"A keyword list of all paths that are includable from this resource","ref":"dsl-ashjsonapi-resource.html#json_api-includes"},{"type":"DSL","title":"json_api.include_nil_values? - dsl-ashjsonapi-resource","doc":"Whether or not to include properties for values that are nil in the JSON output","ref":"dsl-ashjsonapi-resource.html#json_api-include_nil_values?"},{"type":"DSL","title":"json_api.default_fields - dsl-ashjsonapi-resource","doc":"The fields to include in the object if the `fields` query parameter does not specify. Defaults to all public","ref":"dsl-ashjsonapi-resource.html#json_api-default_fields"},{"type":"DSL","title":"json_api.derive_sort? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-derive_sort?"},{"type":"DSL","title":"json_api.derive_filter? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-derive_filter?"},{"type":"DSL","title":"json_api.routes - dsl-ashjsonapi-resource","doc":"Configure the routes that will be exposed via the JSON:API","ref":"dsl-ashjsonapi-resource.html#json_api-routes"},{"type":"DSL","title":"json_api.routes.base - dsl-ashjsonapi-resource","doc":"A base route for the resource, e.g `\"/users\"`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-base"},{"type":"DSL","title":"json_api.routes.get - dsl-ashjsonapi-resource","doc":"A GET route to retrieve a single record","ref":"dsl-ashjsonapi-resource.html#json_api-routes-get"},{"type":"DSL","title":"json_api.routes.get.route - dsl-ashjsonapi-resource","doc":"The path of the route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-get-route"},{"type":"DSL","title":"json_api.routes.get.action - dsl-ashjsonapi-resource","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-resource.html#json_api-routes-get-action"},{"type":"DSL","title":"json_api.routes.get.default_fields - dsl-ashjsonapi-resource","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-get-default_fields"},{"type":"DSL","title":"json_api.routes.get.primary? - dsl-ashjsonapi-resource","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-get-primary?"},{"type":"DSL","title":"json_api.routes.get.metadata - dsl-ashjsonapi-resource","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-resource.html#json_api-routes-get-metadata"},{"type":"DSL","title":"json_api.routes.get.modify_conn - dsl-ashjsonapi-resource","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-get-modify_conn"},{"type":"DSL","title":"json_api.routes.get.name - dsl-ashjsonapi-resource","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-resource.html#json_api-routes-get-name"},{"type":"DSL","title":"json_api.routes.get.derive_sort? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-get-derive_sort?"},{"type":"DSL","title":"json_api.routes.get.derive_filter? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-get-derive_filter?"},{"type":"DSL","title":"json_api.routes.index - dsl-ashjsonapi-resource","doc":"A GET route to retrieve a list of records","ref":"dsl-ashjsonapi-resource.html#json_api-routes-index"},{"type":"DSL","title":"json_api.routes.index.paginate? - dsl-ashjsonapi-resource","doc":"","ref":"dsl-ashjsonapi-resource.html#json_api-routes-index-paginate?"},{"type":"DSL","title":"json_api.routes.index.route - dsl-ashjsonapi-resource","doc":"The path of the route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-index-route"},{"type":"DSL","title":"json_api.routes.index.action - dsl-ashjsonapi-resource","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-resource.html#json_api-routes-index-action"},{"type":"DSL","title":"json_api.routes.index.default_fields - dsl-ashjsonapi-resource","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-index-default_fields"},{"type":"DSL","title":"json_api.routes.index.primary? - dsl-ashjsonapi-resource","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-index-primary?"},{"type":"DSL","title":"json_api.routes.index.metadata - dsl-ashjsonapi-resource","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-resource.html#json_api-routes-index-metadata"},{"type":"DSL","title":"json_api.routes.index.modify_conn - dsl-ashjsonapi-resource","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-index-modify_conn"},{"type":"DSL","title":"json_api.routes.index.name - dsl-ashjsonapi-resource","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-resource.html#json_api-routes-index-name"},{"type":"DSL","title":"json_api.routes.index.derive_sort? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-index-derive_sort?"},{"type":"DSL","title":"json_api.routes.index.derive_filter? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-index-derive_filter?"},{"type":"DSL","title":"json_api.routes.post - dsl-ashjsonapi-resource","doc":"A POST route to create a record","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post"},{"type":"DSL","title":"json_api.routes.post.route - dsl-ashjsonapi-resource","doc":"The path of the route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-route"},{"type":"DSL","title":"json_api.routes.post.action - dsl-ashjsonapi-resource","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-action"},{"type":"DSL","title":"json_api.routes.post.default_fields - dsl-ashjsonapi-resource","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-default_fields"},{"type":"DSL","title":"json_api.routes.post.primary? - dsl-ashjsonapi-resource","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-primary?"},{"type":"DSL","title":"json_api.routes.post.metadata - dsl-ashjsonapi-resource","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-metadata"},{"type":"DSL","title":"json_api.routes.post.modify_conn - dsl-ashjsonapi-resource","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-modify_conn"},{"type":"DSL","title":"json_api.routes.post.query_params - dsl-ashjsonapi-resource","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-query_params"},{"type":"DSL","title":"json_api.routes.post.name - dsl-ashjsonapi-resource","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-name"},{"type":"DSL","title":"json_api.routes.post.derive_sort? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-derive_sort?"},{"type":"DSL","title":"json_api.routes.post.derive_filter? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-derive_filter?"},{"type":"DSL","title":"json_api.routes.post.relationship_arguments - dsl-ashjsonapi-resource","doc":"Arguments to be used to edit relationships. See the [relationships guide](/documentation/topics/relationships.md) for more.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-relationship_arguments"},{"type":"DSL","title":"json_api.routes.post.upsert? - dsl-ashjsonapi-resource","doc":"Whether or not to use the `upsert?: true` option when calling `Ash.create/2`.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-upsert?"},{"type":"DSL","title":"json_api.routes.post.upsert_identity - dsl-ashjsonapi-resource","doc":"Which identity to use for the upsert","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post-upsert_identity"},{"type":"DSL","title":"json_api.routes.patch - dsl-ashjsonapi-resource","doc":"A PATCH route to update a record","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch"},{"type":"DSL","title":"json_api.routes.patch.relationship_arguments - dsl-ashjsonapi-resource","doc":"Arguments to be used to edit relationships. See the [relationships guide](/documentation/topics/relationships.md) for more.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch-relationship_arguments"},{"type":"DSL","title":"json_api.routes.patch.read_action - dsl-ashjsonapi-resource","doc":"The read action to use to look the record up before updating","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch-read_action"},{"type":"DSL","title":"json_api.routes.patch.route - dsl-ashjsonapi-resource","doc":"The path of the route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch-route"},{"type":"DSL","title":"json_api.routes.patch.action - dsl-ashjsonapi-resource","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch-action"},{"type":"DSL","title":"json_api.routes.patch.default_fields - dsl-ashjsonapi-resource","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch-default_fields"},{"type":"DSL","title":"json_api.routes.patch.primary? - dsl-ashjsonapi-resource","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch-primary?"},{"type":"DSL","title":"json_api.routes.patch.metadata - dsl-ashjsonapi-resource","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch-metadata"},{"type":"DSL","title":"json_api.routes.patch.modify_conn - dsl-ashjsonapi-resource","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch-modify_conn"},{"type":"DSL","title":"json_api.routes.patch.query_params - dsl-ashjsonapi-resource","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch-query_params"},{"type":"DSL","title":"json_api.routes.patch.name - dsl-ashjsonapi-resource","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch-name"},{"type":"DSL","title":"json_api.routes.patch.derive_sort? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch-derive_sort?"},{"type":"DSL","title":"json_api.routes.patch.derive_filter? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch-derive_filter?"},{"type":"DSL","title":"json_api.routes.delete - dsl-ashjsonapi-resource","doc":"A DELETE route to destroy a record","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete"},{"type":"DSL","title":"json_api.routes.delete.read_action - dsl-ashjsonapi-resource","doc":"The read action to use to look the record up before updating","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete-read_action"},{"type":"DSL","title":"json_api.routes.delete.route - dsl-ashjsonapi-resource","doc":"The path of the route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete-route"},{"type":"DSL","title":"json_api.routes.delete.action - dsl-ashjsonapi-resource","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete-action"},{"type":"DSL","title":"json_api.routes.delete.default_fields - dsl-ashjsonapi-resource","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete-default_fields"},{"type":"DSL","title":"json_api.routes.delete.primary? - dsl-ashjsonapi-resource","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete-primary?"},{"type":"DSL","title":"json_api.routes.delete.metadata - dsl-ashjsonapi-resource","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete-metadata"},{"type":"DSL","title":"json_api.routes.delete.modify_conn - dsl-ashjsonapi-resource","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete-modify_conn"},{"type":"DSL","title":"json_api.routes.delete.query_params - dsl-ashjsonapi-resource","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete-query_params"},{"type":"DSL","title":"json_api.routes.delete.name - dsl-ashjsonapi-resource","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete-name"},{"type":"DSL","title":"json_api.routes.delete.derive_sort? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete-derive_sort?"},{"type":"DSL","title":"json_api.routes.delete.derive_filter? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete-derive_filter?"},{"type":"DSL","title":"json_api.routes.related - dsl-ashjsonapi-resource","doc":"A GET route to read the related resources of a relationship","ref":"dsl-ashjsonapi-resource.html#json_api-routes-related"},{"type":"DSL","title":"json_api.routes.related.relationship - dsl-ashjsonapi-resource","doc":"","ref":"dsl-ashjsonapi-resource.html#json_api-routes-related-relationship"},{"type":"DSL","title":"json_api.routes.related.route - dsl-ashjsonapi-resource","doc":"The path of the route - Defaults to /:id/[relationship_name]","ref":"dsl-ashjsonapi-resource.html#json_api-routes-related-route"},{"type":"DSL","title":"json_api.routes.related.action - dsl-ashjsonapi-resource","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-resource.html#json_api-routes-related-action"},{"type":"DSL","title":"json_api.routes.related.default_fields - dsl-ashjsonapi-resource","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-related-default_fields"},{"type":"DSL","title":"json_api.routes.related.primary? - dsl-ashjsonapi-resource","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-related-primary?"},{"type":"DSL","title":"json_api.routes.related.metadata - dsl-ashjsonapi-resource","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-resource.html#json_api-routes-related-metadata"},{"type":"DSL","title":"json_api.routes.related.modify_conn - dsl-ashjsonapi-resource","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-related-modify_conn"},{"type":"DSL","title":"json_api.routes.related.query_params - dsl-ashjsonapi-resource","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-related-query_params"},{"type":"DSL","title":"json_api.routes.related.name - dsl-ashjsonapi-resource","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-resource.html#json_api-routes-related-name"},{"type":"DSL","title":"json_api.routes.related.derive_sort? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-related-derive_sort?"},{"type":"DSL","title":"json_api.routes.related.derive_filter? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-related-derive_filter?"},{"type":"DSL","title":"json_api.routes.relationship - dsl-ashjsonapi-resource","doc":"A READ route to read the relationship, returns resource identifiers.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-relationship"},{"type":"DSL","title":"json_api.routes.relationship.relationship - dsl-ashjsonapi-resource","doc":"","ref":"dsl-ashjsonapi-resource.html#json_api-routes-relationship-relationship"},{"type":"DSL","title":"json_api.routes.relationship.route - dsl-ashjsonapi-resource","doc":"The path of the route -  Defaults to /:id/relationships/[relationship_name]","ref":"dsl-ashjsonapi-resource.html#json_api-routes-relationship-route"},{"type":"DSL","title":"json_api.routes.relationship.action - dsl-ashjsonapi-resource","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-resource.html#json_api-routes-relationship-action"},{"type":"DSL","title":"json_api.routes.relationship.default_fields - dsl-ashjsonapi-resource","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-relationship-default_fields"},{"type":"DSL","title":"json_api.routes.relationship.primary? - dsl-ashjsonapi-resource","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-relationship-primary?"},{"type":"DSL","title":"json_api.routes.relationship.metadata - dsl-ashjsonapi-resource","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-resource.html#json_api-routes-relationship-metadata"},{"type":"DSL","title":"json_api.routes.relationship.modify_conn - dsl-ashjsonapi-resource","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-relationship-modify_conn"},{"type":"DSL","title":"json_api.routes.relationship.query_params - dsl-ashjsonapi-resource","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-relationship-query_params"},{"type":"DSL","title":"json_api.routes.relationship.name - dsl-ashjsonapi-resource","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-resource.html#json_api-routes-relationship-name"},{"type":"DSL","title":"json_api.routes.relationship.derive_sort? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-relationship-derive_sort?"},{"type":"DSL","title":"json_api.routes.relationship.derive_filter? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-relationship-derive_filter?"},{"type":"DSL","title":"json_api.routes.post_to_relationship - dsl-ashjsonapi-resource","doc":"A POST route to create related entities using resource identifiers","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post_to_relationship"},{"type":"DSL","title":"json_api.routes.post_to_relationship.relationship - dsl-ashjsonapi-resource","doc":"","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post_to_relationship-relationship"},{"type":"DSL","title":"json_api.routes.post_to_relationship.route - dsl-ashjsonapi-resource","doc":"The path of the route -  Defaults to /:id/relationships/[relationship_name]","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post_to_relationship-route"},{"type":"DSL","title":"json_api.routes.post_to_relationship.default_fields - dsl-ashjsonapi-resource","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post_to_relationship-default_fields"},{"type":"DSL","title":"json_api.routes.post_to_relationship.primary? - dsl-ashjsonapi-resource","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post_to_relationship-primary?"},{"type":"DSL","title":"json_api.routes.post_to_relationship.metadata - dsl-ashjsonapi-resource","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post_to_relationship-metadata"},{"type":"DSL","title":"json_api.routes.post_to_relationship.modify_conn - dsl-ashjsonapi-resource","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post_to_relationship-modify_conn"},{"type":"DSL","title":"json_api.routes.post_to_relationship.query_params - dsl-ashjsonapi-resource","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post_to_relationship-query_params"},{"type":"DSL","title":"json_api.routes.post_to_relationship.name - dsl-ashjsonapi-resource","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post_to_relationship-name"},{"type":"DSL","title":"json_api.routes.post_to_relationship.derive_sort? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post_to_relationship-derive_sort?"},{"type":"DSL","title":"json_api.routes.post_to_relationship.derive_filter? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-post_to_relationship-derive_filter?"},{"type":"DSL","title":"json_api.routes.patch_relationship - dsl-ashjsonapi-resource","doc":"A PATCH route to update a relationship using resource identifiers","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch_relationship"},{"type":"DSL","title":"json_api.routes.patch_relationship.relationship - dsl-ashjsonapi-resource","doc":"","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch_relationship-relationship"},{"type":"DSL","title":"json_api.routes.patch_relationship.route - dsl-ashjsonapi-resource","doc":"The path of the route -  Defaults to /:id/relationships/[relationship_name]","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch_relationship-route"},{"type":"DSL","title":"json_api.routes.patch_relationship.default_fields - dsl-ashjsonapi-resource","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch_relationship-default_fields"},{"type":"DSL","title":"json_api.routes.patch_relationship.primary? - dsl-ashjsonapi-resource","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch_relationship-primary?"},{"type":"DSL","title":"json_api.routes.patch_relationship.metadata - dsl-ashjsonapi-resource","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch_relationship-metadata"},{"type":"DSL","title":"json_api.routes.patch_relationship.modify_conn - dsl-ashjsonapi-resource","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch_relationship-modify_conn"},{"type":"DSL","title":"json_api.routes.patch_relationship.query_params - dsl-ashjsonapi-resource","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch_relationship-query_params"},{"type":"DSL","title":"json_api.routes.patch_relationship.name - dsl-ashjsonapi-resource","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch_relationship-name"},{"type":"DSL","title":"json_api.routes.patch_relationship.derive_sort? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch_relationship-derive_sort?"},{"type":"DSL","title":"json_api.routes.patch_relationship.derive_filter? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-patch_relationship-derive_filter?"},{"type":"DSL","title":"json_api.routes.delete_from_relationship - dsl-ashjsonapi-resource","doc":"A DELETE route to remove related entities using resource identifiers","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete_from_relationship"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.relationship - dsl-ashjsonapi-resource","doc":"","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete_from_relationship-relationship"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.route - dsl-ashjsonapi-resource","doc":"The path of the route -  Defaults to /:id/relationships/[relationship_name]","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete_from_relationship-route"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.default_fields - dsl-ashjsonapi-resource","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete_from_relationship-default_fields"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.primary? - dsl-ashjsonapi-resource","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete_from_relationship-primary?"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.metadata - dsl-ashjsonapi-resource","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete_from_relationship-metadata"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.modify_conn - dsl-ashjsonapi-resource","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete_from_relationship-modify_conn"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.query_params - dsl-ashjsonapi-resource","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete_from_relationship-query_params"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.name - dsl-ashjsonapi-resource","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete_from_relationship-name"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.derive_sort? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete_from_relationship-derive_sort?"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.derive_filter? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-delete_from_relationship-derive_filter?"},{"type":"DSL","title":"json_api.routes.route - dsl-ashjsonapi-resource","doc":"A route for a generic action.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route"},{"type":"DSL","title":"json_api.routes.route.wrap_in_result? - dsl-ashjsonapi-resource","doc":"Whether or not the action result should be wrapped in `{result:  }`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route-wrap_in_result?"},{"type":"DSL","title":"json_api.routes.route.method - dsl-ashjsonapi-resource","doc":"The HTTP method for the route, e.g `:get`, or `:post`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route-method"},{"type":"DSL","title":"json_api.routes.route.route - dsl-ashjsonapi-resource","doc":"The path of the route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route-route"},{"type":"DSL","title":"json_api.routes.route.action - dsl-ashjsonapi-resource","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route-action"},{"type":"DSL","title":"json_api.routes.route.default_fields - dsl-ashjsonapi-resource","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route-default_fields"},{"type":"DSL","title":"json_api.routes.route.primary? - dsl-ashjsonapi-resource","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route-primary?"},{"type":"DSL","title":"json_api.routes.route.metadata - dsl-ashjsonapi-resource","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route-metadata"},{"type":"DSL","title":"json_api.routes.route.modify_conn - dsl-ashjsonapi-resource","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route-modify_conn"},{"type":"DSL","title":"json_api.routes.route.query_params - dsl-ashjsonapi-resource","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route-query_params"},{"type":"DSL","title":"json_api.routes.route.name - dsl-ashjsonapi-resource","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route-name"},{"type":"DSL","title":"json_api.routes.route.derive_sort? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route-derive_sort?"},{"type":"DSL","title":"json_api.routes.route.derive_filter? - dsl-ashjsonapi-resource","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-resource.html#json_api-routes-route-derive_filter?"},{"type":"DSL","title":"json_api.primary_key - dsl-ashjsonapi-resource","doc":"Encode the id of the JSON API response from selected attributes of a resource","ref":"dsl-ashjsonapi-resource.html#json_api-primary_key"},{"type":"DSL","title":"json_api.primary_key.keys - dsl-ashjsonapi-resource","doc":"the list of attributes to encode JSON API primary key","ref":"dsl-ashjsonapi-resource.html#json_api-primary_key-keys"},{"type":"DSL","title":"json_api.primary_key.delimiter - dsl-ashjsonapi-resource","doc":"The delimiter to concatenate the primary key values. Default to be '-'","ref":"dsl-ashjsonapi-resource.html#json_api-primary_key-delimiter"},{"type":"DSL","title":"json_api - dsl-ashjsonapi-domain","doc":"Global configuration for JSON:API","ref":"dsl-ashjsonapi-domain.html#json_api"},{"type":"DSL","title":"json_api.router - dsl-ashjsonapi-domain","doc":"The router that you created for this Domain. Used by test helpers to send requests","ref":"dsl-ashjsonapi-domain.html#json_api-router"},{"type":"DSL","title":"json_api.show_raised_errors? - dsl-ashjsonapi-domain","doc":"For security purposes, if an error is *raised* then Ash simply shows a generic error. If you want to show those errors, set this to true.","ref":"dsl-ashjsonapi-domain.html#json_api-show_raised_errors?"},{"type":"DSL","title":"json_api.prefix - dsl-ashjsonapi-domain","doc":"The route prefix at which you are serving the JSON:API","ref":"dsl-ashjsonapi-domain.html#json_api-prefix"},{"type":"DSL","title":"json_api.serve_schema? - dsl-ashjsonapi-domain","doc":"Whether or not create a /schema route that serves the JSON schema of your API","ref":"dsl-ashjsonapi-domain.html#json_api-serve_schema?"},{"type":"DSL","title":"json_api.authorize? - dsl-ashjsonapi-domain","doc":"Whether or not to perform authorization on requests.","ref":"dsl-ashjsonapi-domain.html#json_api-authorize?"},{"type":"DSL","title":"json_api.log_errors? - dsl-ashjsonapi-domain","doc":"Whether or not to log any errors produced","ref":"dsl-ashjsonapi-domain.html#json_api-log_errors?"},{"type":"DSL","title":"json_api.include_nil_values? - dsl-ashjsonapi-domain","doc":"Whether or not to include properties for values that are nil in the JSON output","ref":"dsl-ashjsonapi-domain.html#json_api-include_nil_values?"},{"type":"DSL","title":"json_api.open_api - dsl-ashjsonapi-domain","doc":"OpenAPI configurations","ref":"dsl-ashjsonapi-domain.html#json_api-open_api"},{"type":"DSL","title":"json_api.open_api.tag - dsl-ashjsonapi-domain","doc":"Tag to be used when used by :group_by","ref":"dsl-ashjsonapi-domain.html#json_api-open_api-tag"},{"type":"DSL","title":"json_api.open_api.group_by - dsl-ashjsonapi-domain","doc":"Group by :domain or :resource","ref":"dsl-ashjsonapi-domain.html#json_api-open_api-group_by"},{"type":"DSL","title":"json_api.routes - dsl-ashjsonapi-domain","doc":"Configure the routes that will be exposed via the JSON:API","ref":"dsl-ashjsonapi-domain.html#json_api-routes"},{"type":"DSL","title":"json_api.routes.base_route - dsl-ashjsonapi-domain","doc":"Sets a prefix for a list of contained routes","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route"},{"type":"DSL","title":"json_api.routes.base_route.route - dsl-ashjsonapi-domain","doc":"The route prefix to use for contained routes","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route"},{"type":"DSL","title":"json_api.routes.base_route.resource - dsl-ashjsonapi-domain","doc":"The resource that the contained routes will use by default","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-resource"},{"type":"DSL","title":"json_api.routes.base_route.get - dsl-ashjsonapi-domain","doc":"A GET route to retrieve a single record","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-get"},{"type":"DSL","title":"json_api.routes.base_route.get.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-get-resource"},{"type":"DSL","title":"json_api.routes.base_route.get.route - dsl-ashjsonapi-domain","doc":"The path of the route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-get-route"},{"type":"DSL","title":"json_api.routes.base_route.get.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-get-action"},{"type":"DSL","title":"json_api.routes.base_route.get.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-get-default_fields"},{"type":"DSL","title":"json_api.routes.base_route.get.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-get-primary?"},{"type":"DSL","title":"json_api.routes.base_route.get.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-get-metadata"},{"type":"DSL","title":"json_api.routes.base_route.get.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-get-modify_conn"},{"type":"DSL","title":"json_api.routes.base_route.get.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-get-name"},{"type":"DSL","title":"json_api.routes.base_route.get.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-get-derive_sort?"},{"type":"DSL","title":"json_api.routes.base_route.get.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-get-derive_filter?"},{"type":"DSL","title":"json_api.routes.base_route.index - dsl-ashjsonapi-domain","doc":"A GET route to retrieve a list of records","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-index"},{"type":"DSL","title":"json_api.routes.base_route.index.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-index-resource"},{"type":"DSL","title":"json_api.routes.base_route.index.paginate? - dsl-ashjsonapi-domain","doc":"","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-index-paginate?"},{"type":"DSL","title":"json_api.routes.base_route.index.route - dsl-ashjsonapi-domain","doc":"The path of the route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-index-route"},{"type":"DSL","title":"json_api.routes.base_route.index.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-index-action"},{"type":"DSL","title":"json_api.routes.base_route.index.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-index-default_fields"},{"type":"DSL","title":"json_api.routes.base_route.index.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-index-primary?"},{"type":"DSL","title":"json_api.routes.base_route.index.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-index-metadata"},{"type":"DSL","title":"json_api.routes.base_route.index.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-index-modify_conn"},{"type":"DSL","title":"json_api.routes.base_route.index.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-index-name"},{"type":"DSL","title":"json_api.routes.base_route.index.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-index-derive_sort?"},{"type":"DSL","title":"json_api.routes.base_route.index.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-index-derive_filter?"},{"type":"DSL","title":"json_api.routes.base_route.post - dsl-ashjsonapi-domain","doc":"A POST route to create a record","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post"},{"type":"DSL","title":"json_api.routes.base_route.post.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-resource"},{"type":"DSL","title":"json_api.routes.base_route.post.route - dsl-ashjsonapi-domain","doc":"The path of the route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-route"},{"type":"DSL","title":"json_api.routes.base_route.post.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-action"},{"type":"DSL","title":"json_api.routes.base_route.post.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-default_fields"},{"type":"DSL","title":"json_api.routes.base_route.post.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-primary?"},{"type":"DSL","title":"json_api.routes.base_route.post.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-metadata"},{"type":"DSL","title":"json_api.routes.base_route.post.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-modify_conn"},{"type":"DSL","title":"json_api.routes.base_route.post.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-query_params"},{"type":"DSL","title":"json_api.routes.base_route.post.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-name"},{"type":"DSL","title":"json_api.routes.base_route.post.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-derive_sort?"},{"type":"DSL","title":"json_api.routes.base_route.post.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-derive_filter?"},{"type":"DSL","title":"json_api.routes.base_route.post.relationship_arguments - dsl-ashjsonapi-domain","doc":"Arguments to be used to edit relationships. See the [relationships guide](/documentation/topics/relationships.md) for more.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-relationship_arguments"},{"type":"DSL","title":"json_api.routes.base_route.post.upsert? - dsl-ashjsonapi-domain","doc":"Whether or not to use the `upsert?: true` option when calling `Ash.create/2`.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-upsert?"},{"type":"DSL","title":"json_api.routes.base_route.post.upsert_identity - dsl-ashjsonapi-domain","doc":"Which identity to use for the upsert","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post-upsert_identity"},{"type":"DSL","title":"json_api.routes.base_route.patch - dsl-ashjsonapi-domain","doc":"A PATCH route to update a record","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch"},{"type":"DSL","title":"json_api.routes.base_route.patch.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-resource"},{"type":"DSL","title":"json_api.routes.base_route.patch.relationship_arguments - dsl-ashjsonapi-domain","doc":"Arguments to be used to edit relationships. See the [relationships guide](/documentation/topics/relationships.md) for more.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-relationship_arguments"},{"type":"DSL","title":"json_api.routes.base_route.patch.read_action - dsl-ashjsonapi-domain","doc":"The read action to use to look the record up before updating","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-read_action"},{"type":"DSL","title":"json_api.routes.base_route.patch.route - dsl-ashjsonapi-domain","doc":"The path of the route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-route"},{"type":"DSL","title":"json_api.routes.base_route.patch.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-action"},{"type":"DSL","title":"json_api.routes.base_route.patch.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-default_fields"},{"type":"DSL","title":"json_api.routes.base_route.patch.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-primary?"},{"type":"DSL","title":"json_api.routes.base_route.patch.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-metadata"},{"type":"DSL","title":"json_api.routes.base_route.patch.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-modify_conn"},{"type":"DSL","title":"json_api.routes.base_route.patch.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-query_params"},{"type":"DSL","title":"json_api.routes.base_route.patch.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-name"},{"type":"DSL","title":"json_api.routes.base_route.patch.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-derive_sort?"},{"type":"DSL","title":"json_api.routes.base_route.patch.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch-derive_filter?"},{"type":"DSL","title":"json_api.routes.base_route.delete - dsl-ashjsonapi-domain","doc":"A DELETE route to destroy a record","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete"},{"type":"DSL","title":"json_api.routes.base_route.delete.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete-resource"},{"type":"DSL","title":"json_api.routes.base_route.delete.read_action - dsl-ashjsonapi-domain","doc":"The read action to use to look the record up before updating","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete-read_action"},{"type":"DSL","title":"json_api.routes.base_route.delete.route - dsl-ashjsonapi-domain","doc":"The path of the route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete-route"},{"type":"DSL","title":"json_api.routes.base_route.delete.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete-action"},{"type":"DSL","title":"json_api.routes.base_route.delete.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete-default_fields"},{"type":"DSL","title":"json_api.routes.base_route.delete.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete-primary?"},{"type":"DSL","title":"json_api.routes.base_route.delete.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete-metadata"},{"type":"DSL","title":"json_api.routes.base_route.delete.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete-modify_conn"},{"type":"DSL","title":"json_api.routes.base_route.delete.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete-query_params"},{"type":"DSL","title":"json_api.routes.base_route.delete.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete-name"},{"type":"DSL","title":"json_api.routes.base_route.delete.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete-derive_sort?"},{"type":"DSL","title":"json_api.routes.base_route.delete.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete-derive_filter?"},{"type":"DSL","title":"json_api.routes.base_route.related - dsl-ashjsonapi-domain","doc":"A GET route to read the related resources of a relationship","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related"},{"type":"DSL","title":"json_api.routes.base_route.related.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related-resource"},{"type":"DSL","title":"json_api.routes.base_route.related.relationship - dsl-ashjsonapi-domain","doc":"","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related-relationship"},{"type":"DSL","title":"json_api.routes.base_route.related.route - dsl-ashjsonapi-domain","doc":"The path of the route - Defaults to /:id/[relationship_name]","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related-route"},{"type":"DSL","title":"json_api.routes.base_route.related.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related-action"},{"type":"DSL","title":"json_api.routes.base_route.related.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related-default_fields"},{"type":"DSL","title":"json_api.routes.base_route.related.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related-primary?"},{"type":"DSL","title":"json_api.routes.base_route.related.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related-metadata"},{"type":"DSL","title":"json_api.routes.base_route.related.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related-modify_conn"},{"type":"DSL","title":"json_api.routes.base_route.related.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related-query_params"},{"type":"DSL","title":"json_api.routes.base_route.related.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related-name"},{"type":"DSL","title":"json_api.routes.base_route.related.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related-derive_sort?"},{"type":"DSL","title":"json_api.routes.base_route.related.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-related-derive_filter?"},{"type":"DSL","title":"json_api.routes.base_route.relationship - dsl-ashjsonapi-domain","doc":"A READ route to read the relationship, returns resource identifiers.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship"},{"type":"DSL","title":"json_api.routes.base_route.relationship.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship-resource"},{"type":"DSL","title":"json_api.routes.base_route.relationship.relationship - dsl-ashjsonapi-domain","doc":"","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship-relationship"},{"type":"DSL","title":"json_api.routes.base_route.relationship.route - dsl-ashjsonapi-domain","doc":"The path of the route -  Defaults to /:id/relationships/[relationship_name]","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship-route"},{"type":"DSL","title":"json_api.routes.base_route.relationship.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship-action"},{"type":"DSL","title":"json_api.routes.base_route.relationship.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship-default_fields"},{"type":"DSL","title":"json_api.routes.base_route.relationship.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship-primary?"},{"type":"DSL","title":"json_api.routes.base_route.relationship.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship-metadata"},{"type":"DSL","title":"json_api.routes.base_route.relationship.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship-modify_conn"},{"type":"DSL","title":"json_api.routes.base_route.relationship.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship-query_params"},{"type":"DSL","title":"json_api.routes.base_route.relationship.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship-name"},{"type":"DSL","title":"json_api.routes.base_route.relationship.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship-derive_sort?"},{"type":"DSL","title":"json_api.routes.base_route.relationship.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-relationship-derive_filter?"},{"type":"DSL","title":"json_api.routes.base_route.post_to_relationship - dsl-ashjsonapi-domain","doc":"A POST route to create related entities using resource identifiers","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post_to_relationship"},{"type":"DSL","title":"json_api.routes.base_route.post_to_relationship.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post_to_relationship-resource"},{"type":"DSL","title":"json_api.routes.base_route.post_to_relationship.relationship - dsl-ashjsonapi-domain","doc":"","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post_to_relationship-relationship"},{"type":"DSL","title":"json_api.routes.base_route.post_to_relationship.route - dsl-ashjsonapi-domain","doc":"The path of the route -  Defaults to /:id/relationships/[relationship_name]","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post_to_relationship-route"},{"type":"DSL","title":"json_api.routes.base_route.post_to_relationship.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post_to_relationship-default_fields"},{"type":"DSL","title":"json_api.routes.base_route.post_to_relationship.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post_to_relationship-primary?"},{"type":"DSL","title":"json_api.routes.base_route.post_to_relationship.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post_to_relationship-metadata"},{"type":"DSL","title":"json_api.routes.base_route.post_to_relationship.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post_to_relationship-modify_conn"},{"type":"DSL","title":"json_api.routes.base_route.post_to_relationship.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post_to_relationship-query_params"},{"type":"DSL","title":"json_api.routes.base_route.post_to_relationship.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post_to_relationship-name"},{"type":"DSL","title":"json_api.routes.base_route.post_to_relationship.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post_to_relationship-derive_sort?"},{"type":"DSL","title":"json_api.routes.base_route.post_to_relationship.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-post_to_relationship-derive_filter?"},{"type":"DSL","title":"json_api.routes.base_route.patch_relationship - dsl-ashjsonapi-domain","doc":"A PATCH route to update a relationship using resource identifiers","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch_relationship"},{"type":"DSL","title":"json_api.routes.base_route.patch_relationship.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch_relationship-resource"},{"type":"DSL","title":"json_api.routes.base_route.patch_relationship.relationship - dsl-ashjsonapi-domain","doc":"","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch_relationship-relationship"},{"type":"DSL","title":"json_api.routes.base_route.patch_relationship.route - dsl-ashjsonapi-domain","doc":"The path of the route -  Defaults to /:id/relationships/[relationship_name]","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch_relationship-route"},{"type":"DSL","title":"json_api.routes.base_route.patch_relationship.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch_relationship-default_fields"},{"type":"DSL","title":"json_api.routes.base_route.patch_relationship.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch_relationship-primary?"},{"type":"DSL","title":"json_api.routes.base_route.patch_relationship.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch_relationship-metadata"},{"type":"DSL","title":"json_api.routes.base_route.patch_relationship.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch_relationship-modify_conn"},{"type":"DSL","title":"json_api.routes.base_route.patch_relationship.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch_relationship-query_params"},{"type":"DSL","title":"json_api.routes.base_route.patch_relationship.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch_relationship-name"},{"type":"DSL","title":"json_api.routes.base_route.patch_relationship.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch_relationship-derive_sort?"},{"type":"DSL","title":"json_api.routes.base_route.patch_relationship.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-patch_relationship-derive_filter?"},{"type":"DSL","title":"json_api.routes.base_route.delete_from_relationship - dsl-ashjsonapi-domain","doc":"A DELETE route to remove related entities using resource identifiers","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete_from_relationship"},{"type":"DSL","title":"json_api.routes.base_route.delete_from_relationship.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete_from_relationship-resource"},{"type":"DSL","title":"json_api.routes.base_route.delete_from_relationship.relationship - dsl-ashjsonapi-domain","doc":"","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete_from_relationship-relationship"},{"type":"DSL","title":"json_api.routes.base_route.delete_from_relationship.route - dsl-ashjsonapi-domain","doc":"The path of the route -  Defaults to /:id/relationships/[relationship_name]","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete_from_relationship-route"},{"type":"DSL","title":"json_api.routes.base_route.delete_from_relationship.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete_from_relationship-default_fields"},{"type":"DSL","title":"json_api.routes.base_route.delete_from_relationship.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete_from_relationship-primary?"},{"type":"DSL","title":"json_api.routes.base_route.delete_from_relationship.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete_from_relationship-metadata"},{"type":"DSL","title":"json_api.routes.base_route.delete_from_relationship.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete_from_relationship-modify_conn"},{"type":"DSL","title":"json_api.routes.base_route.delete_from_relationship.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete_from_relationship-query_params"},{"type":"DSL","title":"json_api.routes.base_route.delete_from_relationship.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete_from_relationship-name"},{"type":"DSL","title":"json_api.routes.base_route.delete_from_relationship.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete_from_relationship-derive_sort?"},{"type":"DSL","title":"json_api.routes.base_route.delete_from_relationship.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-delete_from_relationship-derive_filter?"},{"type":"DSL","title":"json_api.routes.base_route.route - dsl-ashjsonapi-domain","doc":"A route for a generic action.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route"},{"type":"DSL","title":"json_api.routes.base_route.route.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-resource"},{"type":"DSL","title":"json_api.routes.base_route.route.wrap_in_result? - dsl-ashjsonapi-domain","doc":"Whether or not the action result should be wrapped in `{result:  }`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-wrap_in_result?"},{"type":"DSL","title":"json_api.routes.base_route.route.method - dsl-ashjsonapi-domain","doc":"The HTTP method for the route, e.g `:get`, or `:post`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-method"},{"type":"DSL","title":"json_api.routes.base_route.route.route - dsl-ashjsonapi-domain","doc":"The path of the route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-route"},{"type":"DSL","title":"json_api.routes.base_route.route.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-action"},{"type":"DSL","title":"json_api.routes.base_route.route.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-default_fields"},{"type":"DSL","title":"json_api.routes.base_route.route.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-primary?"},{"type":"DSL","title":"json_api.routes.base_route.route.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-metadata"},{"type":"DSL","title":"json_api.routes.base_route.route.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-modify_conn"},{"type":"DSL","title":"json_api.routes.base_route.route.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-query_params"},{"type":"DSL","title":"json_api.routes.base_route.route.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-name"},{"type":"DSL","title":"json_api.routes.base_route.route.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-derive_sort?"},{"type":"DSL","title":"json_api.routes.base_route.route.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-base_route-route-derive_filter?"},{"type":"DSL","title":"json_api.routes.get - dsl-ashjsonapi-domain","doc":"A GET route to retrieve a single record","ref":"dsl-ashjsonapi-domain.html#json_api-routes-get"},{"type":"DSL","title":"json_api.routes.get.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-get-resource"},{"type":"DSL","title":"json_api.routes.get.route - dsl-ashjsonapi-domain","doc":"The path of the route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-get-route"},{"type":"DSL","title":"json_api.routes.get.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-get-action"},{"type":"DSL","title":"json_api.routes.get.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-get-default_fields"},{"type":"DSL","title":"json_api.routes.get.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-get-primary?"},{"type":"DSL","title":"json_api.routes.get.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-get-metadata"},{"type":"DSL","title":"json_api.routes.get.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-get-modify_conn"},{"type":"DSL","title":"json_api.routes.get.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-get-name"},{"type":"DSL","title":"json_api.routes.get.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-get-derive_sort?"},{"type":"DSL","title":"json_api.routes.get.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-get-derive_filter?"},{"type":"DSL","title":"json_api.routes.index - dsl-ashjsonapi-domain","doc":"A GET route to retrieve a list of records","ref":"dsl-ashjsonapi-domain.html#json_api-routes-index"},{"type":"DSL","title":"json_api.routes.index.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-index-resource"},{"type":"DSL","title":"json_api.routes.index.paginate? - dsl-ashjsonapi-domain","doc":"","ref":"dsl-ashjsonapi-domain.html#json_api-routes-index-paginate?"},{"type":"DSL","title":"json_api.routes.index.route - dsl-ashjsonapi-domain","doc":"The path of the route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-index-route"},{"type":"DSL","title":"json_api.routes.index.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-index-action"},{"type":"DSL","title":"json_api.routes.index.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-index-default_fields"},{"type":"DSL","title":"json_api.routes.index.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-index-primary?"},{"type":"DSL","title":"json_api.routes.index.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-index-metadata"},{"type":"DSL","title":"json_api.routes.index.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-index-modify_conn"},{"type":"DSL","title":"json_api.routes.index.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-index-name"},{"type":"DSL","title":"json_api.routes.index.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-index-derive_sort?"},{"type":"DSL","title":"json_api.routes.index.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-index-derive_filter?"},{"type":"DSL","title":"json_api.routes.post - dsl-ashjsonapi-domain","doc":"A POST route to create a record","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post"},{"type":"DSL","title":"json_api.routes.post.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-resource"},{"type":"DSL","title":"json_api.routes.post.route - dsl-ashjsonapi-domain","doc":"The path of the route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-route"},{"type":"DSL","title":"json_api.routes.post.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-action"},{"type":"DSL","title":"json_api.routes.post.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-default_fields"},{"type":"DSL","title":"json_api.routes.post.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-primary?"},{"type":"DSL","title":"json_api.routes.post.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-metadata"},{"type":"DSL","title":"json_api.routes.post.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-modify_conn"},{"type":"DSL","title":"json_api.routes.post.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-query_params"},{"type":"DSL","title":"json_api.routes.post.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-name"},{"type":"DSL","title":"json_api.routes.post.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-derive_sort?"},{"type":"DSL","title":"json_api.routes.post.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-derive_filter?"},{"type":"DSL","title":"json_api.routes.post.relationship_arguments - dsl-ashjsonapi-domain","doc":"Arguments to be used to edit relationships. See the [relationships guide](/documentation/topics/relationships.md) for more.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-relationship_arguments"},{"type":"DSL","title":"json_api.routes.post.upsert? - dsl-ashjsonapi-domain","doc":"Whether or not to use the `upsert?: true` option when calling `Ash.create/2`.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-upsert?"},{"type":"DSL","title":"json_api.routes.post.upsert_identity - dsl-ashjsonapi-domain","doc":"Which identity to use for the upsert","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post-upsert_identity"},{"type":"DSL","title":"json_api.routes.patch - dsl-ashjsonapi-domain","doc":"A PATCH route to update a record","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch"},{"type":"DSL","title":"json_api.routes.patch.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-resource"},{"type":"DSL","title":"json_api.routes.patch.relationship_arguments - dsl-ashjsonapi-domain","doc":"Arguments to be used to edit relationships. See the [relationships guide](/documentation/topics/relationships.md) for more.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-relationship_arguments"},{"type":"DSL","title":"json_api.routes.patch.read_action - dsl-ashjsonapi-domain","doc":"The read action to use to look the record up before updating","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-read_action"},{"type":"DSL","title":"json_api.routes.patch.route - dsl-ashjsonapi-domain","doc":"The path of the route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-route"},{"type":"DSL","title":"json_api.routes.patch.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-action"},{"type":"DSL","title":"json_api.routes.patch.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-default_fields"},{"type":"DSL","title":"json_api.routes.patch.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-primary?"},{"type":"DSL","title":"json_api.routes.patch.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-metadata"},{"type":"DSL","title":"json_api.routes.patch.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-modify_conn"},{"type":"DSL","title":"json_api.routes.patch.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-query_params"},{"type":"DSL","title":"json_api.routes.patch.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-name"},{"type":"DSL","title":"json_api.routes.patch.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-derive_sort?"},{"type":"DSL","title":"json_api.routes.patch.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch-derive_filter?"},{"type":"DSL","title":"json_api.routes.delete - dsl-ashjsonapi-domain","doc":"A DELETE route to destroy a record","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete"},{"type":"DSL","title":"json_api.routes.delete.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete-resource"},{"type":"DSL","title":"json_api.routes.delete.read_action - dsl-ashjsonapi-domain","doc":"The read action to use to look the record up before updating","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete-read_action"},{"type":"DSL","title":"json_api.routes.delete.route - dsl-ashjsonapi-domain","doc":"The path of the route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete-route"},{"type":"DSL","title":"json_api.routes.delete.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete-action"},{"type":"DSL","title":"json_api.routes.delete.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete-default_fields"},{"type":"DSL","title":"json_api.routes.delete.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete-primary?"},{"type":"DSL","title":"json_api.routes.delete.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete-metadata"},{"type":"DSL","title":"json_api.routes.delete.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete-modify_conn"},{"type":"DSL","title":"json_api.routes.delete.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete-query_params"},{"type":"DSL","title":"json_api.routes.delete.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete-name"},{"type":"DSL","title":"json_api.routes.delete.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete-derive_sort?"},{"type":"DSL","title":"json_api.routes.delete.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete-derive_filter?"},{"type":"DSL","title":"json_api.routes.related - dsl-ashjsonapi-domain","doc":"A GET route to read the related resources of a relationship","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related"},{"type":"DSL","title":"json_api.routes.related.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related-resource"},{"type":"DSL","title":"json_api.routes.related.relationship - dsl-ashjsonapi-domain","doc":"","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related-relationship"},{"type":"DSL","title":"json_api.routes.related.route - dsl-ashjsonapi-domain","doc":"The path of the route - Defaults to /:id/[relationship_name]","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related-route"},{"type":"DSL","title":"json_api.routes.related.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related-action"},{"type":"DSL","title":"json_api.routes.related.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related-default_fields"},{"type":"DSL","title":"json_api.routes.related.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related-primary?"},{"type":"DSL","title":"json_api.routes.related.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related-metadata"},{"type":"DSL","title":"json_api.routes.related.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related-modify_conn"},{"type":"DSL","title":"json_api.routes.related.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related-query_params"},{"type":"DSL","title":"json_api.routes.related.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related-name"},{"type":"DSL","title":"json_api.routes.related.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related-derive_sort?"},{"type":"DSL","title":"json_api.routes.related.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-related-derive_filter?"},{"type":"DSL","title":"json_api.routes.relationship - dsl-ashjsonapi-domain","doc":"A READ route to read the relationship, returns resource identifiers.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship"},{"type":"DSL","title":"json_api.routes.relationship.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship-resource"},{"type":"DSL","title":"json_api.routes.relationship.relationship - dsl-ashjsonapi-domain","doc":"","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship-relationship"},{"type":"DSL","title":"json_api.routes.relationship.route - dsl-ashjsonapi-domain","doc":"The path of the route -  Defaults to /:id/relationships/[relationship_name]","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship-route"},{"type":"DSL","title":"json_api.routes.relationship.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship-action"},{"type":"DSL","title":"json_api.routes.relationship.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship-default_fields"},{"type":"DSL","title":"json_api.routes.relationship.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship-primary?"},{"type":"DSL","title":"json_api.routes.relationship.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship-metadata"},{"type":"DSL","title":"json_api.routes.relationship.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship-modify_conn"},{"type":"DSL","title":"json_api.routes.relationship.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship-query_params"},{"type":"DSL","title":"json_api.routes.relationship.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship-name"},{"type":"DSL","title":"json_api.routes.relationship.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship-derive_sort?"},{"type":"DSL","title":"json_api.routes.relationship.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-relationship-derive_filter?"},{"type":"DSL","title":"json_api.routes.post_to_relationship - dsl-ashjsonapi-domain","doc":"A POST route to create related entities using resource identifiers","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post_to_relationship"},{"type":"DSL","title":"json_api.routes.post_to_relationship.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post_to_relationship-resource"},{"type":"DSL","title":"json_api.routes.post_to_relationship.relationship - dsl-ashjsonapi-domain","doc":"","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post_to_relationship-relationship"},{"type":"DSL","title":"json_api.routes.post_to_relationship.route - dsl-ashjsonapi-domain","doc":"The path of the route -  Defaults to /:id/relationships/[relationship_name]","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post_to_relationship-route"},{"type":"DSL","title":"json_api.routes.post_to_relationship.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post_to_relationship-default_fields"},{"type":"DSL","title":"json_api.routes.post_to_relationship.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post_to_relationship-primary?"},{"type":"DSL","title":"json_api.routes.post_to_relationship.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post_to_relationship-metadata"},{"type":"DSL","title":"json_api.routes.post_to_relationship.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post_to_relationship-modify_conn"},{"type":"DSL","title":"json_api.routes.post_to_relationship.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post_to_relationship-query_params"},{"type":"DSL","title":"json_api.routes.post_to_relationship.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post_to_relationship-name"},{"type":"DSL","title":"json_api.routes.post_to_relationship.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post_to_relationship-derive_sort?"},{"type":"DSL","title":"json_api.routes.post_to_relationship.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-post_to_relationship-derive_filter?"},{"type":"DSL","title":"json_api.routes.patch_relationship - dsl-ashjsonapi-domain","doc":"A PATCH route to update a relationship using resource identifiers","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch_relationship"},{"type":"DSL","title":"json_api.routes.patch_relationship.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch_relationship-resource"},{"type":"DSL","title":"json_api.routes.patch_relationship.relationship - dsl-ashjsonapi-domain","doc":"","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch_relationship-relationship"},{"type":"DSL","title":"json_api.routes.patch_relationship.route - dsl-ashjsonapi-domain","doc":"The path of the route -  Defaults to /:id/relationships/[relationship_name]","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch_relationship-route"},{"type":"DSL","title":"json_api.routes.patch_relationship.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch_relationship-default_fields"},{"type":"DSL","title":"json_api.routes.patch_relationship.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch_relationship-primary?"},{"type":"DSL","title":"json_api.routes.patch_relationship.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch_relationship-metadata"},{"type":"DSL","title":"json_api.routes.patch_relationship.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch_relationship-modify_conn"},{"type":"DSL","title":"json_api.routes.patch_relationship.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch_relationship-query_params"},{"type":"DSL","title":"json_api.routes.patch_relationship.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch_relationship-name"},{"type":"DSL","title":"json_api.routes.patch_relationship.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch_relationship-derive_sort?"},{"type":"DSL","title":"json_api.routes.patch_relationship.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-patch_relationship-derive_filter?"},{"type":"DSL","title":"json_api.routes.delete_from_relationship - dsl-ashjsonapi-domain","doc":"A DELETE route to remove related entities using resource identifiers","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete_from_relationship"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete_from_relationship-resource"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.relationship - dsl-ashjsonapi-domain","doc":"","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete_from_relationship-relationship"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.route - dsl-ashjsonapi-domain","doc":"The path of the route -  Defaults to /:id/relationships/[relationship_name]","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete_from_relationship-route"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete_from_relationship-default_fields"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete_from_relationship-primary?"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete_from_relationship-metadata"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete_from_relationship-modify_conn"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete_from_relationship-query_params"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete_from_relationship-name"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete_from_relationship-derive_sort?"},{"type":"DSL","title":"json_api.routes.delete_from_relationship.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-delete_from_relationship-derive_filter?"},{"type":"DSL","title":"json_api.routes.route - dsl-ashjsonapi-domain","doc":"A route for a generic action.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route"},{"type":"DSL","title":"json_api.routes.route.resource - dsl-ashjsonapi-domain","doc":"The resource that the route's action is defined on","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-resource"},{"type":"DSL","title":"json_api.routes.route.wrap_in_result? - dsl-ashjsonapi-domain","doc":"Whether or not the action result should be wrapped in `{result:  }`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-wrap_in_result?"},{"type":"DSL","title":"json_api.routes.route.method - dsl-ashjsonapi-domain","doc":"The HTTP method for the route, e.g `:get`, or `:post`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-method"},{"type":"DSL","title":"json_api.routes.route.route - dsl-ashjsonapi-domain","doc":"The path of the route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-route"},{"type":"DSL","title":"json_api.routes.route.action - dsl-ashjsonapi-domain","doc":"The action to call when this route is hit","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-action"},{"type":"DSL","title":"json_api.routes.route.default_fields - dsl-ashjsonapi-domain","doc":"A list of fields to be shown in the attributes of the called route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-default_fields"},{"type":"DSL","title":"json_api.routes.route.primary? - dsl-ashjsonapi-domain","doc":"Whether or not this is the route that should be linked to by default when rendering links to this type of route","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-primary?"},{"type":"DSL","title":"json_api.routes.route.metadata - dsl-ashjsonapi-domain","doc":"A function to generate arbitrary top-level metadata for the JSON:API response","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-metadata"},{"type":"DSL","title":"json_api.routes.route.modify_conn - dsl-ashjsonapi-domain","doc":"A function to modify the conn before responding. Used for things like setting headers based on the response. Takes `conn, subject, result, request`","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-modify_conn"},{"type":"DSL","title":"json_api.routes.route.query_params - dsl-ashjsonapi-domain","doc":"A list of action inputs to accept as query parameters.","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-query_params"},{"type":"DSL","title":"json_api.routes.route.name - dsl-ashjsonapi-domain","doc":"A globally unique name for this route, to be used when generating docs and open api specifications","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-name"},{"type":"DSL","title":"json_api.routes.route.derive_sort? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a sort parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-derive_sort?"},{"type":"DSL","title":"json_api.routes.route.derive_filter? - dsl-ashjsonapi-domain","doc":"Whether or not to derive a filter parameter based on the sortable fields of the resource","ref":"dsl-ashjsonapi-domain.html#json_api-routes-route-derive_filter?"},{"type":"extras","title":"Change Log","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nSee [Conventional Commits](Https://conventionalcommits.org) for commit guidelines.\n\n<!-- changelog -->\n\n## [v1.4.33](https://github.com/ash-project/ash_json_api/compare/v1.4.32...v1.4.33) (2025-05-30)","ref":"changelog.html"},{"type":"extras","title":"Improvements: - Change Log","doc":"* add support for decimal serialization\n\n## [v1.4.32](https://github.com/ash-project/ash_json_api/compare/v1.4.31...v1.4.32) (2025-05-22)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* wrap includes configuration list\n\n## [v1.4.31](https://github.com/ash-project/ash_json_api/compare/v1.4.30...v1.4.31) (2025-05-15)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* use string names for parameters everywhere in open api spec\n\n* handle more cases where path params collide w/ query params","ref":"changelog.html#bug-fixes-1"},{"type":"extras","title":"Improvements: - Change Log","doc":"* more consistency for route & query params\n\n## [v1.4.30](https://github.com/ash-project/ash_json_api/compare/v1.4.29...v1.4.30) (2025-04-29)","ref":"changelog.html#improvements-1"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* include resource in all formatted routes\n\n* use `flat_map` for resources\n\n* include routes from resources in formatted routes\n\n* add description to map types","ref":"changelog.html#bug-fixes-2"},{"type":"extras","title":"Improvements: - Change Log","doc":"* add `authorize_update_destroy_with_error?` config\n\n* use union descriptions if present\n\n## [v1.4.29](https://github.com/ash-project/ash_json_api/compare/v1.4.28...v1.4.29) (2025-04-21)","ref":"changelog.html#improvements-2"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* don't add routes task alias for phoenix 1.8\n\n* Remove unused `plug_opts` key in formatted routes and simplify route label\n\n* Add a `label` key to generated formatted routes\n\n* correct json_write_schema call order (#325)\n\n* correct json_write_schema call order\n\n## [v1.4.28](https://github.com/ash-project/ash_json_api/compare/v1.4.27...v1.4.28) (2025-04-15)","ref":"changelog.html#bug-fixes-3"},{"type":"extras","title":"Improvements: - Change Log","doc":"* config swagger to use bearer auth (#324)\n\n## [v1.4.27](https://github.com/ash-project/ash_json_api/compare/v1.4.26...v1.4.27) (2025-04-11)","ref":"changelog.html#improvements-3"},{"type":"extras","title":"Improvements: - Change Log","doc":"* remove need for Module.concat\n\n## [v1.4.26](https://github.com/ash-project/ash_json_api/compare/v1.4.25...v1.4.26) (2025-04-11)","ref":"changelog.html#improvements-4"},{"type":"extras","title":"Improvements: - Change Log","doc":"* add `before_dispatch` option to `AshJsonApi.Router`\n\n* support new verified routes behaviour in phx 1.8\n\n## [v1.4.25](https://github.com/ash-project/ash_json_api/compare/v1.4.24...v1.4.25) (2025-04-11)","ref":"changelog.html#improvements-5"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* don't show exception messages in NoSuchInput\n\n## [v1.4.24](https://github.com/ash-project/ash_json_api/compare/v1.4.23...v1.4.24) (2025-04-09)","ref":"changelog.html#bug-fixes-4"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* properly determine aggregate filter types\n\n* attribute descriptions may not be present","ref":"changelog.html#bug-fixes-5"},{"type":"extras","title":"Improvements: - Change Log","doc":"* Support UUIDv7, Time type in AshJsonApi.OpenApi (#322)\n\n* Refactor filter_type/2 of OpenAPI with raw_filter_type/2 (#319)\n\n* Check :description also in AshJsonApi.OpenApi.unwrap_any_of/1 (#318)\n\n* Add description in filter_type/2, raw_filter_type/2 (#315)\n\n* Preserve description with anyOf (#314)\n\n* Impl serializing with load (#313)\n\n* Add description of attributes in OpenAPI.resource_write_attribute_type/3 (#311)\n\n## [v1.4.23](https://github.com/ash-project/ash_json_api/compare/v1.4.22...v1.4.23) (2025-03-25)","ref":"changelog.html#improvements-6"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* move additionalProperties into schema, not properties","ref":"changelog.html#bug-fixes-6"},{"type":"extras","title":"Improvements: - Change Log","doc":"* support more types in OpenApi (#304)\n\n## [v1.4.22](https://github.com/ash-project/ash_json_api/compare/v1.4.21...v1.4.22) (2025-03-19)","ref":"changelog.html#improvements-7"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* remove accidentally commited future code","ref":"changelog.html#bug-fixes-7"},{"type":"extras","title":"Improvements: - Change Log","doc":"* handle NewTypes in write attributes\n\n* add `additionalProperties: false` where possible\n\n## [v1.4.21](https://github.com/ash-project/ash_json_api/compare/v1.4.20...v1.4.21) (2025-03-18)","ref":"changelog.html#improvements-8"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* properly handle nested `anyOf` statements in open api\n\n* show predicate functions in open api spec\n\n## [v1.4.20](https://github.com/ash-project/ash_json_api/compare/v1.4.19...v1.4.20) (2025-03-11)","ref":"changelog.html#bug-fixes-8"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* display primary keys for embedded resources\n\n## [v1.4.19](https://github.com/ash-project/ash_json_api/compare/v1.4.18...v1.4.19) (2025-02-11)","ref":"changelog.html#bug-fixes-9"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* Use debug log level for errors by default (#289)\n\n* ensure that update actions don't require all inputs\n\n* apply default_fields to included relationships","ref":"changelog.html#bug-fixes-10"},{"type":"extras","title":"Improvements: - Change Log","doc":"* add calculation inputs to openapi filter spec\n\n* Include source pointer in the debug logs\r\n\n## [v1.4.18](https://github.com/ash-project/ash_json_api/compare/v1.4.17...v1.4.18) (2025-01-29)","ref":"changelog.html#improvements-9"},{"type":"extras","title":"Improvements: - Change Log","doc":"* On igniter install modify project aliases with expanded routes task (#282)\n\n* Add task for printing ash json routes (#281)\n\n## [v1.4.17](https://github.com/ash-project/ash_json_api/compare/v1.4.16...v1.4.17) (2025-01-27)","ref":"changelog.html#improvements-10"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* don't display calculations just because they are loaded\n\n* use 404 for `Ash.Error.Query.NotFound`\n\n* properly fall back to `filter` or nothing for built-in not Found\n\n* required attributes being marked as nullable in OpenAPI output (#269)\n\n## [v1.4.16](https://github.com/ash-project/ash_json_api/compare/v1.4.15...v1.4.16) (2024-12-23)","ref":"changelog.html#bug-fixes-11"},{"type":"extras","title":"Improvements: - Change Log","doc":"* make testing helpers public and document them\n\n* deprecate the DSL router configuration\n\n## [v1.4.15](https://github.com/ash-project/ash_json_api/compare/v1.4.14...v1.4.15) (2024-12-20)","ref":"changelog.html#improvements-11"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* only use route's fields on top level records\n\n* nested boolean filters accept a list of filters, not a single filter\n\n* encode primary key always when encoding resources as values","ref":"changelog.html#bug-fixes-12"},{"type":"extras","title":"Improvements: - Change Log","doc":"* make igniter optional\n\n## [v1.4.14](https://github.com/ash-project/ash_json_api/compare/v1.4.13...v1.4.14) (2024-11-24)","ref":"changelog.html#improvements-12"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* add opts to all Ash.load calls (#260)\n\n## [v1.4.13](https://github.com/ash-project/ash_json_api/compare/v1.4.12...v1.4.13) (2024-11-04)","ref":"changelog.html#bug-fixes-13"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* mark filters as deepObject\n\n* support `null` input for non-required attributes","ref":"changelog.html#bug-fixes-14"},{"type":"extras","title":"Improvements: - Change Log","doc":"* fix relationship representation & descriptions in open api schema\n\n* add `sort_included` query parameter\n\n* add sort_included query parameter\n\n* accept arbitrary filters (by making it a stupid text field)\n\n## [v1.4.12](https://github.com/ash-project/ash_json_api/compare/v1.4.11...v1.4.12) (2024-10-21)","ref":"changelog.html#improvements-13"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* hide private arguments in open api (#247)\n\n## [v1.4.11](https://github.com/ash-project/ash_json_api/compare/v1.4.10...v1.4.11) (2024-10-14)","ref":"changelog.html#bug-fixes-15"},{"type":"extras","title":"Improvements: - Change Log","doc":"* add type handler for NaiveDatetime\n\n## [v1.4.10](https://github.com/ash-project/ash_json_api/compare/v1.4.9...v1.4.10) (2024-10-10)","ref":"changelog.html#improvements-14"},{"type":"extras","title":"Improvements: - Change Log","doc":"* set status only if it hasn't already been set\n\n* better examples for `fields` parameter\n\n## [v1.4.9](https://github.com/ash-project/ash_json_api/compare/v1.4.8...v1.4.9) (2024-09-27)","ref":"changelog.html#improvements-15"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* properly strip double slashes from base_route prefixes\n\n* properly render post to relationship and friends in open api spec\n\n* support keyset & offset pagination when mixed in open api schema","ref":"changelog.html#bug-fixes-16"},{"type":"extras","title":"Improvements: - Change Log","doc":"* support providing the open api schema as a file\n\n## [v1.4.8](https://github.com/ash-project/ash_json_api/compare/v1.4.7...v1.4.8) (2024-09-16)","ref":"changelog.html#improvements-16"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* don't access `message` key of `InvalidKeyset` errors","ref":"changelog.html#bug-fixes-17"},{"type":"extras","title":"Improvements: - Change Log","doc":"* upgrade to latest igniter functions and version\n\n## [v1.4.7](https://github.com/ash-project/ash_json_api/compare/v1.4.6...v1.4.7) (2024-09-04)","ref":"changelog.html#improvements-17"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* decode path parameters automatically\n\n## [v1.4.6](https://github.com/ash-project/ash_json_api/compare/v1.4.5...v1.4.6) (2024-08-26)","ref":"changelog.html#bug-fixes-18"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* don't intercept typed structs\n\n* properly check for domain inclusion in json api router when installing","ref":"changelog.html#bug-fixes-19"},{"type":"extras","title":"Improvements: - Change Log","doc":"* support new struct types w/ constraints\n\n## [v1.4.5](https://github.com/ash-project/ash_json_api/compare/v1.4.4...v1.4.5) (2024-08-20)","ref":"changelog.html#improvements-18"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* properly discover all necessary filter schemas","ref":"changelog.html#bug-fixes-20"},{"type":"extras","title":"Improvements: - Change Log","doc":"* optimize post-operation field loading logic\n\n* don't show tags for resources w/o routes in schema\n\n## [v1.4.4](https://github.com/ash-project/ash_json_api/compare/v1.4.3...v1.4.4) (2024-08-16)","ref":"changelog.html#improvements-19"},{"type":"extras","title":"Improvements: - Change Log","doc":"* support nested `base_route`s\n\n## [v1.4.3](https://github.com/ash-project/ash_json_api/compare/v1.4.2...v1.4.3) (2024-08-08)","ref":"changelog.html#improvements-20"},{"type":"extras","title":"Improvements: - Change Log","doc":"* new `AshJsonApi.Type` behaviour, and support returning regular maps\n\n## [v1.4.2](https://github.com/ash-project/ash_json_api/compare/v1.4.1...v1.4.2) (2024-08-08)","ref":"changelog.html#improvements-21"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* use a list when calling `Module.concat`\n\n## [v1.4.1](https://github.com/ash-project/ash_json_api/compare/v1.4.0...v1.4.1) (2024-07-30)","ref":"changelog.html#bug-fixes-21"},{"type":"extras","title":"Improvements: - Change Log","doc":"* properly install domain with `Module.concat` in AshJsonApi router\n\n* include multipart parser in installer\n\n## [v1.4.0](https://github.com/ash-project/ash_json_api/compare/v1.3.8...v1.4.0) (2024-07-30)","ref":"changelog.html#improvements-22"},{"type":"extras","title":"Features: - Change Log","doc":"- [`Ash.Type.File`] Ash.Type.File support (#214)\n\nSee `AshJsonApi.Plug.Parser` for usage information.","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [attributes] reject allow_nil_input fields in required_write_attributes (#219)\n\n- [Open API] properly document query_params from generic routes in open api spec\n\n- [Open API] only include referenced resource types in definitions\n\n- [Open API] properly spec (and test the spec) for actions that return resources\n\n## [v1.3.8](https://github.com/ash-project/ash_json_api/compare/v1.3.7...v1.3.8) (2024-07-22)","ref":"changelog.html#bug-fixes-22"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [`AshJsonApi.Router`] don't double escape `modify_open_api`","ref":"changelog.html#bug-fixes-23"},{"type":"extras","title":"Improvements: - Change Log","doc":"- [`AshJsonApi.Router`] automatically infer the `prefix` instead of relying on configuration\n\n- [`mix ash.patch.extend`] add `AshJsonApi` extender\n\n- [`mix ash_json_api.install`] add installer for AshJsonApi\n\n## [v1.3.7](https://github.com/ash-project/ash_json_api/compare/v1.3.6...v1.3.7) (2024-07-15)","ref":"changelog.html#improvements-23"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [open api] escape `modify_open_api_schema` option since it can be a 3/tuple\n\n- [errors] handle unknown errors in `log_errors/2`\n\n- [serialization] relationship resource identifiers don't need to check the `id` type\n\n- [serialization] properly reference related record in linkage\n\n- [serialization] ensure id is always coming back as a string\n\n## [v1.3.6](https://github.com/ash-project/ash_json_api/compare/v1.3.5...v1.3.6) (2024-07-08)","ref":"changelog.html#bug-fixes-24"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [open api] properly match enum types on input/output\n\n- [errors] Avoid raising the condition converting the regex to string. (#204)","ref":"changelog.html#bug-fixes-25"},{"type":"extras","title":"Improvements: - Change Log","doc":"- [content type negotation] honor `allow_all_media_type_params?` in `content-type` as well\n\n## [v1.3.5](https://github.com/ash-project/ash_json_api/compare/v1.3.4...v1.3.5) (2024-07-06)","ref":"changelog.html#improvements-24"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [bugfix] use `conn.private`, not `conn[:private]`\n\n## [v1.3.4](https://github.com/ash-project/ash_json_api/compare/v1.3.3...v1.3.4) (2024-07-05)","ref":"changelog.html#bug-fixes-26"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [errors] add leading slash to JSON pointer in schema errors (#199)\n\n- [open api] avoid failing openapi generation for non existing resource actions (#198)\n\n## [v1.3.3](https://github.com/ash-project/ash_json_api/compare/v1.3.2...v1.3.3) (2024-07-04)","ref":"changelog.html#bug-fixes-27"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [serialization] ensure generic action bodies, both in & out are serialized properly\n\n- [open api] properly fetch nested types\n\n- [open api] show embedded types when used with `:struct`\n\n- [open api] ensure `action.require_attributes` is stringified in json schema\n\n- [fields parameter] honor resource-level default_fields\n\n## [v1.3.2](https://github.com/ash-project/ash_json_api/compare/v1.3.1...v1.3.2) (2024-07-02)","ref":"changelog.html#bug-fixes-28"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [routes] ensure that context is threaded through for all actions\n\n- [open api] properly require `success` in return-less actions\n\n- [open api] typo when checking for resource's derive_filter? flag\n\n- [open api] not all accepted attributes have to be public\n\n- [open api] fix sort regex to be a valid regex\n\n- [open api] don't use `anyOf` for nullability\n\n- [open api] don't generate bodies for delete requests\n\n- [open api] use `Enum.uniq` when uwnrapping any_of types\n\n- [open api] detect all cases where a filter must be generated","ref":"changelog.html#bug-fixes-29"},{"type":"extras","title":"Improvements: - Change Log","doc":"- [open api] use empty example for filter\n\n- [routes] support for query parameters using `query_params` route option\n\n## [v1.3.1](https://github.com/ash-project/ash_json_api/compare/v1.3.0...v1.3.1) (2024-07-01)","ref":"changelog.html#improvements-25"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [open api] use strings for enum values\n\n- [open api] use `strings` for includes/sort properly, add regex for sort\n\n## [v1.3.0](https://github.com/ash-project/ash_json_api/compare/v1.2.2...v1.3.0) (2024-06-28)","ref":"changelog.html#bug-fixes-30"},{"type":"extras","title":"Features: - Change Log","doc":"- [calculations] add support for calculation inputs via field_inputs query param (#187)\n\n- [routes] support generic actions with no returns in routes\n\n- [routes] support `modify_conn/4`\n\n- [routes] support `:read` actions in `:post` request\n\n- [routes] generic action support for all basic route types\n\n- [routes] new `route/3` type for arbitrary generic actions\n\n- [AshJsonApi.Resource] support `derive_filter?` on both resource and route level\n\n- [AshJsonApi.Resource] support `derive_sort?` on both resource and route level","ref":"changelog.html#features-1"},{"type":"extras","title":"Improvements: - Change Log","doc":"- [OpenApi] implement `Ash.Type.Map` json schema\n\n- [OpenApi] support unions in schemas\n\n- [OpenApi] use \"any object\" type for filter in json schema\n\n- [OpenApi] fully specify filter in open api schema\n\n- [OpenApi] show all sortable fields in json schema\n\n- [OpenApi] Use resource descriptions in generated schema files if present (#184)\n\n- [OpenApi] show embeds in json schema and openapi\n\n- [errors] Add defimpl for NoSuchInput error (#181)\n\n## [v1.2.2](https://github.com/ash-project/ash_json_api/compare/v1.2.1...v1.2.2) (2024-06-19)","ref":"changelog.html#improvements-26"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [include] properly still perform includes on record fetched from path","ref":"changelog.html#bug-fixes-31"},{"type":"extras","title":"Improvements: - Change Log","doc":"- [OpenApi] newtype/enum support for json_schema as well\n\n- [OpenApi] render enums as enums in open api\n\n## [v1.2.1](https://github.com/ash-project/ash_json_api/compare/v1.2.0...v1.2.1) (2024-06-18)","ref":"changelog.html#improvements-27"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [routes] don't raise error including on get related endpoints\n\n- [routes] validate relationships from routes at compile time\n\n- [errors] don't show exceptions if `show_raised_errors?` is `false`\n\n- [errors] add missing fields from `InvalidField`\n\n- [OpenApi] don't expose `action.name` over api docs\n\n- [AshJsonApi.Domain] resource comes from the route on domains","ref":"changelog.html#bug-fixes-32"},{"type":"extras","title":"Improvements: - Change Log","doc":"- [routes] support `name` on `routes`, use in description and operationId\n\n- [AshJsonApi.Resource] verify includes list at compile time\n\n- [AshJsonApi.Domain] allow setting a `resource` second option on domain's `base_route` entity\n\n## [v1.2.0](https://github.com/ash-project/ash_json_api/compare/v1.1.2...v1.2.0) (2024-06-11)","ref":"changelog.html#improvements-28"},{"type":"extras","title":"Features: - Change Log","doc":"- [AshJsonApi.Domain] add `base_route` constructor to domain router","ref":"changelog.html#features-2"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [AshJsonApi.Resource] properly reflect that `default: false` makes a non required attribute\n\n- [AshJsonApi.Resource] non-public attributes can be accepted and required in 3.0\n\n- [AshJsonApi.Resource] support `require_attributes` in json schema\n\n- [AshJsonApi.Resource] ensure that resource-level default_fields are honored","ref":"changelog.html#bug-fixes-33"},{"type":"extras","title":"Improvements: - Change Log","doc":"- [attributes] non-public attributes can be accepted in 3.0\n\n## [v1.1.2](https://github.com/ash-project/ash_json_api/compare/v1.1.1...v1.1.2) (2024-06-05)","ref":"changelog.html#improvements-29"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [includes] ensure we don't drop includes (as a result of deduplicating them)\n\n## [v1.1.1](https://github.com/ash-project/ash_json_api/compare/v1.1.0...v1.1.1) (2024-06-05)","ref":"changelog.html#bug-fixes-34"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [includes] deduplicate includes list while building it","ref":"changelog.html#bug-fixes-35"},{"type":"extras","title":"Improvements: - Change Log","doc":"- [metadata] add ability to supply custom route metadata (#152)\n\n## [v1.1.0](https://github.com/ash-project/ash_json_api/compare/v1.0.0...v1.1.0) (2024-05-24)","ref":"changelog.html#improvements-30"},{"type":"extras","title":"Features: - Change Log","doc":"- [AshJsonApi.Domain] support routes defined on the domain\n\n## [v1.0.0](https://github.com/ash-project/ash_json_api/compare/v1.0.0...v0.34.2)\n\nThis changelog has been restarted. See `/documentation/0.x-CHANGELOG.md` for previous changelogs.","ref":"changelog.html#features-3"},{"type":"extras","title":"Breaking Changes: - Change Log","doc":"- [AshJsonApi.Resource] relationship routes now depend on the action taking an argument with the same name as the relationship. See the upgrade for more.\n\n- [AshJsonApi.ToJsonApiError] Introduced `AshJsonApi.ToJsonApiError` to convert errors to JSON API errors. This brings it more in line with other Ash extensions.","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- [AshJsonApi.Resource] create/update/destroy actions now use bulk operations\n- [AshJsonApi.Router] router is now a dynamic hand-written router. This prevents compile time dependencies.\n- [AshJsonApi.Error] honor path when building source pointers","ref":"changelog.html#improvements-31"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}